static const char code[] = "\n\
proc time2real v {\n\
global uscale\n\
foreach u [array names uscale] {\n\
set k [string first $u $v]\n\
if { $k >= 0 } {\n\
set scale $uscale($u)\n\
break\n\
}\n\
}\n\
if { $k > 0 } {\n\
set v [string range $v 0 [expr $k - 1]]\n\
set v [expr $scale * $v]\n\
}\n\
return $v\n\
}\n\
proc bw2real v {\n\
return [time2real $v]\n\
}\n\
\n\
proc step_format t {\n\
if { $t < 1e-3 } {\n\
return [format \"%.1f\" [expr $t * 1e6]]us\n\
} elseif { $t < 1. } {\n\
return [format \"%.1f\" [expr $t * 1e3]]ms\n\
}\n\
return [format \"%.1f\" $t]s\n\
}\n\
\n\
proc yesno attr {\n\
set v [resource $attr]\n\
if { [string match \\[0-9\\]* $v] } {\n\
return $v\n\
}\n\
if { $v == \"true\" || $v == \"True\" || $v == \"t\" || $v == \"y\" ||\n\
$v == \"yes\" } {\n\
return 1\n\
}\n\
return 0\n\
}\n\
\n\
proc resource s {\n\
return [option get . $s Nam]\n\
}\n\
\n\
proc mapf s { return $s }\n\
\n\
proc set_app_options { name } {\n\
global helv10 helv10b helv10o helv12 helv12b helv14 helv14b times14 \\\n\
ff tcl_platform\n\
\n\
option add $name.foundry adobe startupFile\n\
set ff [option get . foundry $name]\n\
\n\
set helv10 [mapf \"-$ff-helvetica-medium-r-normal--*-100-75-75-*-*-*-*\"]\n\
set helv10b [mapf \"-$ff-helvetica-bold-r-normal--*-100-75-75-*-*-*-*\"]\n\
set helv10o [mapf \"-$ff-helvetica-bold-o-normal--*-100-75-75-*-*-*-*\"]\n\
set helv12 [mapf \"-$ff-helvetica-medium-r-normal--*-120-75-75-*-*-*-*\"]\n\
set helv12b [mapf \"-$ff-helvetica-bold-r-normal--*-120-75-75-*-*-*-*\"]\n\
set helv14 [mapf \"-$ff-helvetica-medium-r-normal--*-140-75-75-*-*-*-*\"]\n\
set helv14b [mapf \"-$ff-helvetica-bold-r-normal--*-140-75-75-*-*-*-*\"]\n\
set times14 [mapf  \"-$ff-times-medium-r-normal--*-140-75-75-*-*-*-*\"]\n\
\n\
if {$tcl_platform(platform)!=\"windows\"} {\n\
option add *font $helv12b startupFile\n\
option add *Font $helv12b startupFile\n\
}\n\
\n\
option add $name.disablefont $helv10o startupFile\n\
option add $name.smallfont $helv10b startupFile\n\
option add $name.medfont $helv12b  startupFile\n\
option add $name.helpFont $times14 startupFile\n\
option add $name.entryFont $helv10 startupFile\n\
\n\
option add $name.rate		2ms	startupFile\n\
option add $name.movie		0	startupFile\n\
option add $name.granularity	40	startupFile\n\
option add $name.pause		1	startupFile\n\
}\n\
\n\
if {$tcl_platform(platform)!=\"windows\"} {\n\
option add *foreground black startupFile\n\
option add *background gray80 startupFile\n\
option add *activeForeground black startupFile\n\
option add *activeBackground gray90 startupFile\n\
option add *viewBackground gray90 startupFile\n\
option add *disabledForeground gray50 startupFile\n\
\n\
} else {\n\
option add *foreground SystemButtonText startupFile\n\
option add *background SystemButtonFace startupFile\n\
option add *viewBackground SystemButtonHighlight startupFile\n\
option add *activeForeground SystemHighlightText startupFile\n\
option add *activeBackground SystemHighlight startupFile\n\
option add *disabledForeground SystemDisabledText startupFile\n\
}\n\
\n\
option add *Radiobutton.relief flat startupFile\n\
\n\
option add *padX 2 startupFile\n\
option add *padY 2 startupFile\n\
option add *tearOff 0 startupFile\n\
\n\
proc smallfont { } {\n\
return [option get . smallfont Nam]\n\
}\n\
proc mediumfont { } {\n\
return [option get . medfont Nam]\n\
}\n\
\n\
proc nam_angle { v } {\n\
switch -regexp $v {\n\
^[0-9\\.]+deg$    { regexp  {([0-9\\.]+)deg$} $v a dval\n\
return [expr {fmod($dval,360)/180}] }\n\
\n\
^[0-9\\.]+$	{ return $v }\n\
\n\
^up-right$ -\n\
^right-up$	{ return 0.25 }\n\
\n\
\n\
^up$		{ return 0.5 }\n\
\n\
^up-left$ -\n\
^left-up$	{ return 0.75 }\n\
\n\
^left$		{ return 1. }\n\
\n\
^left-down$ -\n\
^down-left$	{ return 1.25 }\n\
\n\
^down$		{ return 1.5 }\n\
\n\
^down-right$ -\n\
^right-down$	{ return 1.75 }\n\
\n\
default		{ return 0.0 }\n\
}\n\
}\n\
\n\
proc remote_cmd { async interp cmd } {\n\
if $async {\n\
set rcmd \"send -async \\\"$interp\\\" {$cmd}\"\n\
} else {\n\
set rcmd \"send \\\"$interp\\\" {$cmd}\"\n\
}\n\
eval $rcmd\n\
}\n\
\n\
proc get_trace_item { tag traceevent} {\n\
set next 0\n\
foreach item $traceevent {\n\
if { $next == 1 } {\n\
return $item\n\
}\n\
if { $item == $tag } {\n\
set next 1\n\
} \n\
}\n\
return \"\"\n\
}\n\
\n\
proc place_frame { w f x y } {\n\
set nh [winfo height $w]\n\
set nw [winfo width $w]\n\
place $f -x $nw -y $nh -bordermode outside\n\
update\n\
set ih [winfo reqheight $f]\n\
set iw [winfo reqwidth $f]\n\
set px $x\n\
set py $y\n\
if {($px + $iw) > $nw} {\n\
set px [expr $x - $iw]\n\
if {$px < 0} { set px 0 }\n\
}\n\
if {($py + $ih) > $nh} {\n\
set py [expr $y - $ih]\n\
if {$py < 0} {set py 0}\n\
}\n\
place $f -x $px -y $py -bordermode outside\n\
}\n\
\n\
\n\
\n\
Class AnimControl \n\
\n\
AnimControl instproc init {trace_file args} {\n\
AnimControl instvar PORT_FILE_\n\
\n\
catch \"array set opts $args\"\n\
if [info exists opts(a)] {\n\
set flag 1\n\
} elseif {[file exists $PORT_FILE_] && [file readable $PORT_FILE_]} {\n\
set flag 0\n\
} else {\n\
set flag 1\n\
}\n\
if $flag {\n\
$self local-create-animator $trace_file $args\n\
} else {\n\
eval $self remote-create-animator $trace_file $args\n\
}\n\
}\n\
\n\
proc ::AnimCtrlOnRemoteRequest args {\n\
eval [AnimControl instance] on-remote-request $args\n\
}\n\
\n\
AnimControl instproc on-remote-request { newsock addr port } {\n\
\n\
gets $newsock line\n\
set buf [split $line]\n\
switch [lindex $buf 0] {\n\
CA {\n\
set trace_file [lindex $buf 1]\n\
set args [lrange $buf 2 end]\n\
eval $self create-animator $trace_file $args\n\
}\n\
default {\n\
puts \"Unsupported command [lindex $buf 0]\"\n\
}\n\
}\n\
close $newsock\n\
}\n\
\n\
AnimControl instproc start-server {} {\n\
$self instvar NAM_PORT_ NAM_SOCK_\n\
AnimControl instvar INIT_PORT_ PORT_FILE_\n\
set NAM_PORT_ $INIT_PORT_\n\
\n\
set ret 1\n\
while $ret {\n\
incr NAM_PORT_\n\
set ret [catch {set NAM_SOCK_ \\\n\
[socket -server ::AnimCtrlOnRemoteRequest $NAM_PORT_]}]\n\
}\n\
\n\
set f [open $PORT_FILE_ w 0600]\n\
puts -nonewline $f $NAM_PORT_\n\
close $f\n\
}\n\
\n\
AnimControl instproc remote-create-animator {trace_file args} {\n\
AnimControl instvar PORT_FILE_\n\
if [catch {set f [open $PORT_FILE_ RDONLY]}] {\n\
error \"Cannot read server port from $PORT_FILE_\"\n\
}\n\
set port [read $f]\n\
close $f\n\
\n\
if [catch {set sock [socket localhost $port]}] {\n\
puts -nonewline \"Cannot connect to existing nam instance. \"\n\
puts \"Starting a new one...\"\n\
$self local-create-animator $trace_file [join $args]\n\
} else {\n\
if {$trace_file == \"\"} {\n\
puts \"A nam instance already exists. Use nam <trace file> to view an animation\"\n\
close $sock\n\
exit 0\n\
}\n\
if [regexp {^[~/]} $trace_file] {\n\
set tf $trace_file	;# Absolute pathname\n\
} else {\n\
set tf [pwd]/$trace_file ;# Relative pathname\n\
}\n\
puts $sock \"CA $tf [join $args]\"\n\
flush $sock\n\
close $sock\n\
exit 0\n\
}\n\
}\n\
\n\
AnimControl instproc local-init {} {\n\
$self instvar nam_name wix tagnum animators_\n\
\n\
. configure -background [option get . background Nam]\n\
set_app_options [tk appname]\n\
\n\
set nam_name \"  VINT Network Animator v[version]\"\n\
set wix 0\n\
set tagnum 0\n\
set animators_ {}\n\
\n\
$self build-menu \n\
$self bind-window .\n\
\n\
AnimControl instvar instance_ \n\
if {$instance_ == \"\"} { \n\
set instance_ $self \n\
} else {\n\
error \"Couldn't instantiate more than one AnimControl!\"\n\
}\n\
\n\
wm title . \"[tk appname] Console\"\n\
}\n\
\n\
AnimControl proc instance {} {\n\
set ac [AnimControl set instance_]\n\
if {$ac != \"\"} {\n\
return $ac\n\
}\n\
error \"Couldn't find instance of AnimControl\"\n\
}\n\
\n\
AnimControl instproc bind-window { w } {\n\
bind $w <Control-o> \"$self on-open\"\n\
bind $w <Control-O> \"$self on-open\"\n\
bind $w <Control-q> \"$self done\"\n\
bind $w <Control-Q> \"$self done\"\n\
bind $w <q> \"$self done\"\n\
}\n\
\n\
AnimControl instproc build-menu {} {\n\
$self instvar nam_name\n\
\n\
frame .menu -relief groove -bd 2\n\
pack .menu -side top -fill x\n\
set padx 4\n\
\n\
set mb .menu.file\n\
set m $mb.m\n\
menubutton $mb -text \"File\" -menu $m -underline 0 \\\n\
-borderwidth 1 \n\
menu $m\n\
$m add command -label \"Open... Ctrl+O\" -command \"$self on-open\"\n\
$m add command -label \"WinList Ctrl+w\" -command \"$self on-winlist\"\n\
$m add separator\n\
$m add command -label \"Quit    Ctrl+Q\" -command \"$self done\"\n\
pack $mb -side left -padx $padx\n\
\n\
label .menu.name -text $nam_name -font [smallfont] \\\n\
-width 30 -borderwidth 2 -relief groove \n\
pack .menu.name -side left -fill x -expand true -padx 4 -pady 1\n\
\n\
set mb .menu.help\n\
set m $mb.m\n\
menubutton $mb -text \"Help\" -menu $m -underline 0 \\\n\
-borderwidth 1 \n\
menu $m\n\
$m add command -label \"Help\" -command \"$self new_web help\"\n\
$m add command -label \"About nam\" -command \"$self new_web about\"\n\
pack $mb -side right -padx $padx\n\
}\n\
\n\
AnimControl instproc done {} {\n\
AnimControl instvar PORT_FILE_\n\
$self instvar animators_ NAM_SOCK_ NAM_PORT_\n\
\n\
close $NAM_SOCK_\n\
if [catch \"set f [open $PORT_FILE_ r]\"] {\n\
puts \"Nam port file already deleted.\"\n\
} else {\n\
set buf [gets $f]\n\
close $f\n\
if {$buf == $NAM_PORT_} {\n\
file delete $PORT_FILE_\n\
} else {\n\
puts \"Another nam instance is running...\"\n\
}\n\
}\n\
foreach a $animators_ {\n\
$a done\n\
}\n\
destroy .\n\
}\n\
\n\
AnimControl instproc on-open {} {\n\
$self tkvar openFile_ openPeer_\n\
set openPeer_ \"\"\n\
\n\
toplevel .openFile\n\
set w .openFile\n\
\n\
wm title $w \"Open Trace File\"\n\
frame $w.f -borderwidth 1 -relief raised\n\
pack $w.f -side top -fill both -expand true\n\
filesel $w.f.sel $w -variable [$self tkvarname openFile_] \\\n\
-command \"$self do-open-tracefile $w.f.sel\" \\\n\
-label \"Trace file to open:\"\n\
pack $w.f.sel -side top -fill both -expand true\n\
\n\
label $w.pl0 -text \"Peer:\"\n\
pack $w.pl0 -side top -anchor w\n\
entry $w.peerentry -width 50 -relief sunken \\\n\
-textvariable [$self tkvar openPeer_]\n\
pack $w.peerentry -side top -fill both -expand true\n\
\n\
frame $w.f.btns -borderwidth 0\n\
pack $w.f.btns -side top -fill x\n\
button $w.f.btns.save -text Open \\\n\
-command \"$self do-open-tracefile $w\"\n\
pack $w.f.btns.save -side left -fill x -expand true\n\
button $w.f.btns.cancel -text Cancel -command \"destroy $w\"\n\
pack $w.f.btns.cancel -side left -fill x -expand true\n\
set openFile_ [pwd]\n\
}\n\
\n\
AnimControl instproc do-open-tracefile {w} {\n\
$self tkvar openFile_ openPeer_\n\
checkfile $openFile_ \"r\" $w.f.sel $w \\\n\
\"$self create-animator $openFile_ p=$openPeer_\"\n\
}\n\
\n\
AnimControl instproc local-create-animator { trace_file args } {\n\
$self local-init\n\
$self start-server\n\
if {$trace_file != \"\"} {\n\
eval $self create-animator $trace_file $args\n\
}\n\
}\n\
\n\
AnimControl instproc create-animator { tracefile args } {\n\
$self instvar animators_\n\
AnimControl instvar ANIMATOR_CLASS_\n\
if ![catch {eval set anim [new $ANIMATOR_CLASS_ $tracefile $args]} errMsg] {\n\
lappend animators_ $anim\n\
$self instvar winlist_\n\
if [info exists winlist_] {\n\
$winlist_ insert end [$anim get-name]\n\
}\n\
} else {\n\
global errorInfo\n\
puts \"Failed to start animator: \"\n\
puts \"$errMsg\"\n\
puts \"$errorInfo\"\n\
}\n\
}\n\
\n\
AnimControl instproc close-animator { animator } {\n\
$self instvar animators_\n\
set pos [lsearch $animators_ $animator]\n\
set animators_ [lreplace $animators_ $pos $pos]\n\
$self instvar winlist_\n\
if [info exists winlist_] {\n\
$winlist_ delete $pos\n\
}\n\
}\n\
\n\
AnimControl instproc on-winlist {} {\n\
$self instvar winlist_ \n\
if [info exists winlist_] {\n\
return\n\
}\n\
\n\
set w .winList\n\
toplevel $w\n\
\n\
wm title $w \"Active Animations\"\n\
\n\
frame $w.f -borderwidth 0 -highlightthickness 0\n\
frame $w.f.f\n\
listbox $w.f.f.a -xscrollcommand \"$w.f.f.ah set\" \\\n\
-yscrollcommand \"$w.f.f2.av set\" -height 10 \\\n\
-selectmode single \n\
pack $w.f.f.a -fill both -side top -expand true \n\
set winlist_ $w.f.f.a\n\
\n\
scrollbar $w.f.f.ah -orient horizontal -width 10 -borderwidth 1 \\\n\
-command \"$w.f.f.a xview\"\n\
$w.f.f.ah set 0.0 1.0\n\
pack $w.f.f.ah -side bottom -fill x -expand true\n\
\n\
frame $w.f.f2\n\
pack $w.f.f2 -side left -fill y\n\
scrollbar $w.f.f2.av -orient vertical -width 10 -borderwidth 1 \\\n\
-command \"$w.f.f.a yview\"\n\
$w.f.f2.av set 0.0 1.0\n\
pack $w.f.f2.av -side top -fill y -expand true\n\
pack $w.f.f -side left -fill both -expand true\n\
pack $w.f -side left -fill both -expand true\n\
\n\
bind $w.f.f.a <Double-ButtonPress-1> \"$self winlist_show $w.f.f.a\"\n\
bind $w.f.f.a <Destroy> \"+$self unset winlist_\"\n\
\n\
$self instvar animators_\n\
foreach a $animators_ {\n\
$w.f.f.a insert end [$a get-name]\n\
}\n\
}\n\
\n\
AnimControl instproc winlist_show { wlbox } {\n\
set idx [$wlbox index active]\n\
$self instvar animators_\n\
raise [[lindex $animators_ $idx] get-tkwin]\n\
}\n\
\n\
Animator instproc init { trace_file args } {\n\
$self instvar windows trace tracefile \\\n\
prevRate rateSlider currRate netModel \\\n\
running peers peerName granularity direction \\\n\
nam_name graphs NETWORK_MODEL nam_record_filename \\\n\
nam_record_frame id_ sliderPressed maxmon analysis_flag \\\n\
colorname fcolorname now mintime maxtime prevTime range \\\n\
welcome analysis_OK analysis_ready nam_version viewctr \\\n\
plotmarks\n\
\n\
$self instvar observerlist_\n\
set observerlist_ \"\"\n\
\n\
$self next\n\
\n\
set id_ [Animator set id_]\n\
Animator set id_ [incr id_]\n\
\n\
Animator instvar SyncAnimator_\n\
if ![info exists SyncAnimator_] {\n\
set SyncAnimator_ {}	;# Empty list\n\
}\n\
$self tkvar isSync_\n\
set isSync_ 0\n\
\n\
set tracefile $trace_file\n\
set nam_name $tracefile\n\
\n\
set analysis_flag 0\n\
set analysis_OK 0\n\
set analysis_ready 0\n\
set nam_version 0\n\
set welcome \"                               Welcome to NamGraph 1.0                                \"\n\
\n\
set NETWORK_MODEL NetworkModel\n\
\n\
set nam_record_filename nam\n\
set nam_record_frame 0\n\
\n\
set sliderPressed 0\n\
set direction 1\n\
set running 0\n\
\n\
set viewctr 0\n\
set maxmon 0\n\
\n\
set colorname(0) black\n\
set colorname(1) navy\n\
set colorname(2) cornflowerblue\n\
set colorname(3) blue\n\
set colorname(4) deepskyblue\n\
set colorname(5) steelblue\n\
set colorname(6) dodgerblue\n\
set colorname(7) darkolivegreen\n\
\n\
set fcolorname(0) red\n\
set fcolorname(1) brown\n\
set fcolorname(2) purple\n\
set fcolorname(3) orange\n\
set fcolorname(4) chocolate\n\
set fcolorname(5) salmon\n\
set fcolorname(6) greenyellow\n\
set fcolorname(7) gold\n\
\n\
\n\
if ![info exists plotmarks] {\n\
set plotmarks(0) mark1\n\
set plotmarks(1) mark2\n\
set plotmarks(2) mark3\n\
set plotmarks(3) mark4\n\
set plotmarks(4) mark5\n\
set plotmarks(5) mark6\n\
set plotmarks(6) mark7\n\
set plotmarks(7) mark8\n\
set plotmarks(8) mark1\n\
set plotmarks(9) mark2\n\
set plotmarks(10) mark3\n\
set plotmarks(11) mark4\n\
set plotmarks(12) mark5\n\
set plotmarks(13) mark6\n\
set plotmarks(14) mark7 \n\
set plotmarks(15) mark8\n\
\n\
}\n\
\n\
\n\
set graphs \"\"\n\
set statsViews \"\"\n\
\n\
$self infer-network-model $tracefile\n\
$self nam_analysis $tracefile\n\
\n\
set netModel [new $NETWORK_MODEL $self $tracefile]\n\
\n\
if [catch {\n\
set trace [new Trace $tracefile $self]\n\
set now [$trace mintime]\n\
set mintime $now\n\
set maxtime [expr [$trace maxtime] + .05]\n\
set range [expr $maxtime - $mintime]\n\
set prevTime $mintime\n\
$trace connect $netModel\n\
} errMsg] {\n\
error \"$errMsg\" \n\
}\n\
\n\
$self build-ui\n\
\n\
set peerName \"\"\n\
set peers \"\"\n\
if {$args != \"\"} {\n\
catch \"array set opts $args\"\n\
if [info exists opts(p)] {\n\
set peerName $opts(p)\n\
peer_init $peerName\n\
}\n\
}\n\
\n\
if [catch {\n\
$self settime $now\n\
$self set_rate $currRate 1\n\
} errMsg] {\n\
error \"$errMsg\" \n\
}\n\
\n\
\n\
$trace connect [new TraceHook $self]\n\
\n\
\n\
}\n\
\n\
Animator instproc infer-network-model { tracefile } {\n\
$self instvar NETWORK_MODEL\n\
set file [open $tracefile \"r\"]\n\
set NETWORK_MODEL NetworkModel\n\
set time \"0\"\n\
while {([eof $file]==0)&&([string compare $time \"*\"]!=0)} {\n\
set line [gets $file]\n\
set time [get_trace_item \"-t\" $line]\n\
}\n\
while {([eof $file]==0)&&([string compare $time \"*\"]==0)} {\n\
set cmd [lindex $line 0]\n\
set time [get_trace_item \"-t\" $line]\n\
if {[string compare $time \"*\"]!=0} {break}\n\
switch $cmd {\n\
\"l\" {\n\
set direction [get_trace_item \"-o\" $line]\n\
if {$direction==\"\"} {\n\
set NETWORK_MODEL NetworkModel/Auto\n\
}\n\
}\n\
\"W\" {\n\
set NETWORK_MODEL NetworkModel/Wireless\n\
set width [get_trace_item \"-x\" $line]\n\
set height [get_trace_item \"-y\" $line]\n\
NetworkModel/Wireless set Wpxmax_ $width\n\
NetworkModel/Wireless set Wpymax_ $height\n\
break\n\
}\n\
}\n\
set line [gets $file]\n\
}\n\
close $file\n\
}\n\
\n\
Animator instproc peer_init { name handle } {\n\
$self peer $name 0 $handle\n\
$self peer_cmd 0 \"peer \\\"[tk appname]\\\" 1 $self\"\n\
}\n\
\n\
Animator instproc peer_cmd { async cmd } {\n\
$self instvar peers\n\
foreach s $peers {\n\
remote_cmd $async [lindex $s 0] \"[lindex $s 1] $cmd\"\n\
}\n\
$self sync_cmd $cmd\n\
}\n\
\n\
Animator instproc sync_cmd { cmd } {\n\
$self tkvar isSync_\n\
if !$isSync_ {\n\
return\n\
}\n\
Animator instvar SyncAnimator_\n\
foreach s $SyncAnimator_ {\n\
if {$s == $self} { continue }\n\
eval $s $cmd\n\
}\n\
}\n\
\n\
Animator instproc peer { name remote handle } {\n\
$self instvar peers\n\
if { $remote } {\n\
peer_cmd 1 \"peer \\\"$name\\\" 0 $self\"\n\
foreach s $peers {\n\
set p [lindex $s 0]\n\
set h [lindex $s 1]\n\
remote_cmd 1 $name \"peer \\\"$p\\\" 0 $h\"\n\
}\n\
}\n\
lappend peers [list $name $handle]\n\
}\n\
\n\
Animator instproc backFrame { } {\n\
$self instvar now timeStep\n\
$self settime [expr $now - $timeStep]\n\
}\n\
\n\
Animator instproc nextFrame { } {\n\
$self instvar now timeStep direction\n\
if {$direction>0} {\n\
$self settime [expr $now + $timeStep]\n\
} else {\n\
$self settime [expr $now - $timeStep]\n\
}\n\
}\n\
\n\
Animator instproc settime t {\n\
$self instvar sliderPressed range mintime timeSlider trace now \\\n\
maxtime graphs netViews statsViews\n\
$self tkvar nowDisp\n\
\n\
if { $t > $maxtime } {\n\
$self stop 1\n\
return\n\
} elseif { $t < $mintime } {\n\
set t $mintime\n\
}\n\
set now $t\n\
set nowDisp [format %.6f $now]\n\
if { $sliderPressed == 0 } {\n\
$self timesliderset [expr int(1000. * ($now - $mintime) / $range)]\n\
}\n\
\n\
\n\
$self notifyObservers $now\n\
\n\
set event [$trace settime $now $sliderPressed]\n\
\n\
foreach graph $graphs {\n\
$graph settime $t\n\
}\n\
foreach netView $netViews {\n\
$self update_monitors $netView $now\n\
}\n\
$self update_annotations $now\n\
}\n\
\n\
Animator instproc slidetime { tick remote } {\n\
$self instvar now range mintime trace\n\
set now [expr ($tick * $range) / 1000. + $mintime]\n\
$self settime $now\n\
if { $remote } {\n\
$self peer_cmd 1 \"settime $now\"\n\
}\n\
}\n\
\n\
Animator instproc recordFrame {} {\n\
$self instvar netViews nam_record_filename nam_record_frame\n\
foreach netView $netViews {\n\
$netView record_frame \"$nam_record_filename$nam_record_frame.xwd\"\n\
incr nam_record_frame\n\
}\n\
}\n\
\n\
Animator instproc renderFrame { } {\n\
$self instvar running direction sliderPressed granularity \\\n\
pending_frame_\n\
$self tkvar nam_record_animation\n\
\n\
if { $running && !$sliderPressed } {\n\
$self nextFrame\n\
update idletasks\n\
if $nam_record_animation {\n\
$self recordFrame\n\
}\n\
set pending_frame_ [after $granularity \"$self renderFrame\"]\n\
}\n\
}\n\
\n\
Animator instproc redrawFrame {} {\n\
$self instvar now\n\
$self settime $now\n\
}\n\
\n\
Animator instproc remote_set_direction {t dir} {\n\
$self instvar direction\n\
$self settime $t\n\
set direction $dir\n\
}\n\
\n\
Animator instproc set_forward_dir remote {\n\
$self instvar direction now \n\
set direction 1\n\
if { $remote } {\n\
$self peer_cmd 1 \"remote_set_direction $now 1\"\n\
}\n\
}\n\
\n\
Animator instproc set_backward_dir remote {\n\
$self instvar direction now\n\
set direction -1\n\
if { $remote } {\n\
$self peer_cmd 1 \"remote_set_direction $now -1\"\n\
}\n\
}\n\
\n\
Animator instproc remote_play t {\n\
$self settime $t\n\
$self play 0\n\
}\n\
\n\
Animator instproc play remote {\n\
$self instvar running now\n\
set running 1\n\
after 0 \"$self renderFrame\"\n\
if { $remote } {\n\
$self peer_cmd 1 \"remote_play $now\"\n\
}\n\
}\n\
\n\
Animator instproc remote_stop t {\n\
$self stop 0\n\
$self settime $t\n\
}\n\
\n\
Animator instproc stop remote {\n\
$self instvar running now\n\
set running 0\n\
if { $remote } {\n\
$self peer_cmd 1 \"remote_stop $now\"\n\
}\n\
}\n\
\n\
Animator instproc reset { } {\n\
$self settime 0.\n\
$self peer_cmd 1 \"settime 0.\"\n\
}\n\
\n\
Animator instproc rewind { } {\n\
$self instvar now timeStep\n\
set t [expr $now - $timeStep*25.0]\n\
$self settime $t\n\
$self peer_cmd 1 \"settime $t\"\n\
}\n\
\n\
Animator instproc fast_fwd { } {\n\
$self instvar now timeStep\n\
set t [expr $now + $timeStep*25.0]\n\
$self settime $t\n\
$self peer_cmd 1 \"settime $t\"\n\
}\n\
\n\
Animator instproc next_event { } {\n\
$self instvar trace running\n\
set t [$trace nxtevent]\n\
$self settime $t\n\
$self peer_cmd 1 \"settime $t\"\n\
if { !$running } {\n\
$self nextFrame\n\
$self peer_cmd 1 nextFrame\n\
}\n\
}\n\
\n\
Animator instproc set_rate_ext { v remote } {\n\
$self instvar timeStep stepDisp rateSlider currRate\n\
set orig_v $v\n\
set timeStep [time2real $v]\n\
set v [expr 10.0 * log10($timeStep)]\n\
set stepDisp [step_format $timeStep]\n\
if { [$rateSlider get] != $v } { $rateSlider set $v }\n\
set currRate $v\n\
if { $remote } {\n\
$self peer_cmd 1 \"set_rate $orig_v 0\"\n\
}\n\
}\n\
\n\
Animator instproc set_rate { v remote } {\n\
$self instvar timeStep stepDisp rateSlider currRate\n\
set orig_v $v\n\
set timeStep [expr pow(10, $v / 10.)]\n\
set stepDisp [step_format $timeStep]\n\
if { [$rateSlider get] != $v } { $rateSlider set $v }\n\
set currRate $v\n\
if { $remote } {\n\
$self peer_cmd 1 \"set_rate $orig_v 0\"\n\
}\n\
}\n\
\n\
Animator instproc time_undo { } {\n\
$self instvar timeSlider prevTime now\n\
set currTime $now\n\
$self settime $prevTime\n\
$self peer_cmd 1 \"settime $prevTime\"\n\
set prevTime $currTime\n\
}\n\
\n\
Animator instproc rate_undo { } {\n\
$self instvar prevRate rateSlider\n\
set tmpRate [$rateSlider get]\n\
$self set_rate $prevRate 1\n\
$rateSlider set $prevRate\n\
set prevRate $tmpRate\n\
}\n\
\n\
\n\
Animator instproc auto_ff { } {\n\
$self tkvar nam_auto_ff\n\
set nam_auto_ff 1\n\
}\n\
\n\
Animator instproc speedup { t } {\n\
$self instvar running \n\
$self tkvar nam_auto_ff\n\
if { $nam_auto_ff && $running } {\n\
$self next_event \n\
}\n\
}\n\
\n\
Animator instproc normalspeed { } {\n\
}\n\
\n\
Animator instproc button_release_1 t {\n\
$self instvar timeSlider sliderPressed\n\
\n\
$self slidetime $t 1\n\
$timeSlider set $t\n\
set sliderPressed 0\n\
}\n\
\n\
Animator instproc button_press_1 s {\n\
$self instvar sliderPressed prevTime\n\
set sliderPressed 1\n\
set prevTime $s\n\
}\n\
\n\
Animator instproc displayStep args {\n\
$self instvar rateSlider stepDisp\n\
$rateSlider configure -label \"Step: $stepDisp\"\n\
}\n\
\n\
Animator instproc back_step { } {\n\
$self instvar running\n\
if $running { $self stop 1 }\n\
$self backFrame\n\
$self peer_cmd 1 backFrame\n\
}\n\
\n\
Animator instproc toggle_pause { } {\n\
$self instvar running\n\
if $running {\n\
$self stop 1\n\
} else {\n\
$self play 1\n\
}\n\
}\n\
\n\
Animator instproc single_step { } {\n\
$self instvar running\n\
if $running { $self stop 1 }\n\
$self nextFrame\n\
$self peer_cmd 1 nextFrame\n\
}\n\
\n\
Animator instproc dead name {\n\
$self instvar peers\n\
set i [lsearch -exact $peers $name]\n\
set peers [lreplace $peers $i $i]\n\
}\n\
\n\
Animator instproc destroy {} {\n\
[AnimControl instance] close-animator $self\n\
$self next\n\
}\n\
\n\
Animator instproc cleanup {} {\n\
if [$self is-sync] {\n\
$self remove-sync $self\n\
}\n\
$self instvar pending_frame_ tlw_\n\
destroy $tlw_\n\
if [info exists pending_frame_] {\n\
after cancel $pending_frame_\n\
}\n\
}\n\
\n\
Animator instproc done { } {\n\
$self peer_cmd 1 \"dead \\\"[tk appname]\\\"\"\n\
$self cleanup\n\
delete $self\n\
}\n\
\n\
Animator instproc all_done { } {\n\
$self peer_cmd 1 \"destroy\"\n\
$self cleanup\n\
delete $self\n\
}\n\
\n\
Animator instproc local_change_rate inc {\n\
$self instvar timeStep stepDisp\n\
if $inc {\n\
set timeStep [expr $timeStep + $timeStep*0.05]\n\
} else {\n\
set timeStep [expr $timeStep - $timeStep*0.05]\n\
}	    \n\
set stepDisp [step_format $timeStep]\n\
}\n\
\n\
Animator instproc change_rate inc {\n\
$self instvar timeStep\n\
$self local_change_rate $inc\n\
$self peer_cmd 1 \"local_change_rate $inc\"\n\
}\n\
\n\
Animator instproc ncolor {n0 color} {\n\
$self instvar netModel\n\
$netModel ncolor $n0 $color\n\
}\n\
\n\
Animator instproc ecolor {n0 n1 color} {\n\
$self instvar netModel\n\
$netModel ecolor $n0 $n1 $color\n\
$netModel ecolor $n1 $n0 $color\n\
}\n\
\n\
Animator instproc add-sync { anim } {\n\
Animator instvar SyncAnimator_\n\
lappend SyncAnimator_ $anim\n\
}\n\
\n\
Animator instproc remove-sync { anim } {\n\
Animator instvar SyncAnimator_\n\
set pos [lsearch $SyncAnimator_ $anim]\n\
if {$pos != -1} {\n\
set SyncAnimator_ [lreplace $SyncAnimator_ $pos $pos]\n\
}\n\
}\n\
\n\
Animator instproc is-sync {} {\n\
$self tkvar isSync_\n\
return $isSync_\n\
}\n\
\n\
Animator instproc get-sync {} {\n\
Animator instvar SyncAnimator_\n\
return $SyncAnimator_\n\
}\n\
\n\
Animator instproc get-name {} {\n\
$self instvar nam_name\n\
return $nam_name\n\
}\n\
\n\
Animator instproc get-tkwin {} {\n\
$self instvar tlw_\n\
return $tlw_\n\
}\n\
\n\
\n\
\n\
Animator instproc addObserver { o } {\n\
$self instvar observerlist_\n\
\n\
set cnt 0\n\
set oid [$o id]\n\
foreach ob $observerlist_ {\n\
set obid [$ob id]\n\
if { $oid == $obid } {\n\
set cnt 1\n\
break;\n\
} \n\
}   \n\
\n\
if { $cnt == 0 } {\n\
lappend observerlist_ $o\n\
}   \n\
}\n\
\n\
\n\
Animator instproc  deleteObserver { o } { \n\
\n\
$self instvar observerlist_\n\
set backlist_ \"\"\n\
set oid [$o id]\n\
foreach ob $observerlist_ {\n\
set obid [$ob id]\n\
if { $oid != $obid } {\n\
lappend backlist_ $ob\n\
} else {\n\
$o destory\n\
}\n\
}\n\
\n\
set observerlist_ $backlist_\n\
}\n\
\n\
Animator instproc notifyObservers { arg } {\n\
\n\
$self instvar observerlist_\n\
\n\
\n\
foreach ob $observerlist_ {\n\
\n\
if ![ catch { $ob info class } ] {\n\
\n\
$ob update $arg\n\
}\n\
}\n\
}\n\
\n\
\n\
Animator instproc countObservers {} {\n\
$self instvar observerlist_\n\
set size [llength $observerlist_]\n\
return $size\n\
}\n\
\n\
\n\
\n\
NetworkModel/Auto set RANDOM_SEED_ 1\n\
NetworkModel/Auto set KCa_ 0.15\n\
NetworkModel/Auto set KCr_ 0.15\n\
NetworkModel/Auto set Recalc_ 1\n\
NetworkModel/Auto set AUTO_ITERATIONS_ 10\n\
NetworkModel/Auto set INCR_ITERATIONS_ 10\n\
\n\
NetworkModel/Auto instproc init { animator tracefile } {\n\
eval $self next $animator $tracefile\n\
NetworkModel/Auto instvar INCR_ITERATIONS_ KCa_ KCr_\n\
$animator set-layout-params $INCR_ITERATIONS_ $KCa_ $KCr_\n\
}\n\
\n\
NetworkModel/Auto instproc do_relayout { Iter Kca Kcr Recalc } {\n\
$self instvar INCR_ITERATIONS_ KCa_ KCr_ Recalc_\n\
set KCa_ $Kca\n\
set KCr_ $Kcr\n\
set Recalc_ $Recalc\n\
set INCR_ITERATIONS_ $Iter\n\
$self relayout\n\
}\n\
\n\
\n\
\n\
Animator instproc popup_annotation { w x y } {\n\
$self instvar annoBox running \n\
$self stop 1\n\
catch {destroy $w.menuPopa}\n\
menu $w.menuPopa -relief groove -borderwidth 2\n\
$w.menuPopa add command -label \"Command\"\n\
$w.menuPopa add separator\n\
$w.menuPopa add command -label \"Add\" \\\n\
-command \"$self cmdAnnotationAdd $w $x $y\"\n\
set index [$annoBox nearest $y]\n\
$w.menuPopa add command -label \"Delete\" \\\n\
-command \"$self cmdAnnotationDelete $index\"\n\
$w.menuPopa add command -label \"Info\" \\\n\
-command \"$self cmdAnnotationInfo $w $index $x $y\"\n\
set rx [winfo rootx $w]\n\
set ry [winfo rooty $w]\n\
set rx [expr $rx + $x]\n\
set ry [expr $ry + $y]\n\
tk_popup $w.menuPopa $rx $ry\n\
}\n\
\n\
Animator instproc cmdAnnotationAdd { w x y } {\n\
$self instvar annoInputText now\n\
\n\
catch { destroy .inputBox }\n\
set f [smallfont]\n\
toplevel .inputBox\n\
label .inputBox.title -text \"New Annotation Text\" -font $f\n\
set annoInputText \"\"\n\
entry .inputBox.input -width 40 -relief sunken \\\n\
-textvariable annoInputText\n\
button .inputBox.done -text \"Done\" -borderwidth 2 -relief raised \\\n\
-font $f \\\n\
-command \"add_annotation $now; catch {destroy .inputBox}\"\n\
pack .inputBox.title -side top\n\
pack .inputBox.input -side top\n\
pack .inputBox.done -side top\n\
\n\
bind .inputBox.input <Return> \\\n\
\"add_annotation $now; catch { destroy .inputBox }\"\n\
}\n\
\n\
Animator instproc cmdAnnotationDelete { index } {\n\
$self instvar annoBox annoTimeList\n\
$annoBox delete $index\n\
set annoTimeList [lreplace $annoTimeList $index $index]\n\
}\n\
\n\
Animator instproc cmdAnnotationInfo { w index x y } {\n\
$self instvar annoBox annoTimeList\n\
set str [$annoBox get $index]\n\
set lst [list \"At time\" [lindex $annoTimeList $index] \", $str\"]\n\
set str [join $lst]\n\
\n\
catch { destroy $w.mBox }\n\
set f [smallfont]\n\
frame $w.mBox -relief groove -borderwidth 2\n\
label $w.mBox.message -text $str -font $f\n\
button $w.mBox.done -text \"Done\" -borderwidth 2 -relief raised \\\n\
-font $f \\\n\
-command \"catch { destroy $w.mBox }\"\n\
pack $w.mBox.message\n\
pack $w.mBox.done\n\
place_frame $w $w.mBox $x $y\n\
}\n\
\n\
Animator instproc add_annotation { time } {\n\
$self instvar annoBox annoTimeList annoInputText\n\
\n\
puts \"Add annotation \\\"$annoInputText\\\" at time $time\"\n\
set size [$annoBox size]\n\
for {set index 0} {$index < $size} {incr index} {\n\
if {[lindex $annoTimeList $index] > $time} {\n\
break\n\
}\n\
}\n\
\n\
if {$index == $size} {\n\
set index \"end\"\n\
}\n\
$annoBox insert $index \"$annoInputText\"\n\
if {$size == 0} {\n\
lappend annoTimeList $time\n\
} else {\n\
set annoTimeList [linsert $annoTimeList $index $time]\n\
}\n\
$annoBox see $index\n\
}\n\
\n\
Animator instproc sim_annotation { time seq args } {\n\
$self instvar annoBox annoTimeList annoBoxHeight regAnno\n\
\n\
if ![info exists regAnno($seq)] {\n\
$annoBox insert end \"$args\"\n\
set size [$annoBox size]\n\
set annoTimeList [lappend annoTimeList $time]\n\
set regAnno($seq) 1\n\
set d [expr $size-$annoBoxHeight]\n\
if {$d > 0} {\n\
$annoBox yview $d\n\
}\n\
}\n\
}\n\
\n\
Animator instproc update_annotations { time } {\n\
$self instvar annoBox annoTimeList annoBoxHeight direction annoJump\n\
\n\
set size [$annoBox size]\n\
if {($size == 0) || ($annoJump == 1)} {\n\
set annoJump 0\n\
return \n\
}\n\
set i 0\n\
foreach l $annoTimeList {\n\
if {$l > $time} {\n\
break\n\
} else {\n\
incr i\n\
}\n\
}\n\
if {$direction != 1 && $i != 0} {\n\
incr i -1\n\
}\n\
if {$i < $annoBoxHeight/2} {\n\
set d 0\n\
} else {\n\
set d [expr $i - $annoBoxHeight / 2]\n\
}\n\
$annoBox yview $d\n\
$annoBox selection clear 0 $size\n\
$annoBox selection set $i $i\n\
}\n\
\n\
Animator instproc jump_to_annotation { anno } {\n\
$self instvar annoTimeList annoJump\n\
set idx [$anno index active]\n\
puts \"Jumping to time [lindex $annoTimeList $idx]\"\n\
set annoJump 1\n\
$self settime [lindex $annoTimeList $idx]\n\
$self peer_cmd 1 \"settime [lindex $annoTimeList $idx]\"\n\
}\n\
\n\
Animator instproc link-up {now src dst} {\n\
$self sim_annotation $now link($src:$dst) up\n\
}\n\
\n\
Animator instproc link-down {now src dst} {\n\
$self sim_annotation $now link($src:$dst) down\n\
}\n\
\n\
Animator instproc node-up {now src} {\n\
$self sim_annotation $now $node $src up\n\
}\n\
\n\
Animator instproc node-down {now src} {\n\
$self sim_annotation $now $node $src down\n\
}\n\
\n\
NetworkModel instproc init { animator tracefile } {\n\
$self next $animator	;# create shadow, etc.\n\
$self nam_addressing $tracefile\n\
$self nam_layout $tracefile\n\
$self layout\n\
}\n\
\n\
NetworkModel instproc nam_addressing { tracefile } {\n\
set file [open $tracefile \"r\"]\n\
set time \"0\"\n\
while {([eof $file]==0)&&([string compare $time \"*\"]!=0)} {\n\
set line [gets $file]\n\
set time [get_trace_item \"-t\" $line]\n\
}\n\
\n\
$self instvar netAddress\n\
if ![info exists netAddress] {\n\
set netAddress [new Address]\n\
}\n\
while {([eof $file]==0)&&([string compare $time \"*\"]==0)} {\n\
set cmd [lindex $line 0]\n\
set time [get_trace_item \"-t\" $line]\n\
if {[string compare $time \"*\"]!=0} {break}\n\
switch $cmd {\n\
\"A\" {\n\
set hier [get_trace_item \"-n\" $line]\n\
if {$hier != \"\"} {\n\
set ps [get_trace_item \"-p\" $line]\n\
set pm [get_trace_item \"-o\" $line]\n\
set ms [get_trace_item \"-c\" $line]\n\
set mm [get_trace_item \"-a\" $line]\n\
$netAddress portbits-are $ps $pm\n\
$netAddress mcastbits-are $ms $mm\n\
} else {\n\
set hier [get_trace_item \"-h\" $line]\n\
set nh [get_trace_item \"-m\" $line]\n\
set nm [get_trace_item \"-s\" $line]\n\
$netAddress add-hier $hier $nh $nm\n\
}\n\
}\n\
}\n\
set line [gets $file]\n\
}\n\
close $file\n\
}\n\
\n\
NetworkModel instproc nam_layout { tracefile } {\n\
set file [open $tracefile \"r\"]\n\
set time \"0\"\n\
while {([eof $file]==0)&&([string compare $time \"*\"]!=0)} {\n\
set line [gets $file]\n\
set time [get_trace_item \"-t\" $line]\n\
}\n\
while {([eof $file]==0)&&([string compare $time \"*\"]==0)} {\n\
set cmd [lindex $line 0]\n\
set time [get_trace_item \"-t\" $line]\n\
if {[string compare $time \"*\"]!=0} {break}\n\
switch $cmd {\n\
\"n\" {\n\
$self layout_node [lrange $line 1 end]\n\
}\n\
\"l\" {\n\
$self layout_link [lrange $line 1 end]\n\
}\n\
\"L\" {\n\
$self layout_lanlink [lrange $line 1 end]\n\
}\n\
\"X\" {\n\
$self layout_lan [lrange $line 1 end]\n\
}\n\
\"q\" {\n\
$self layout_queue [lrange $line 1 end]\n\
}\n\
\"c\" {\n\
$self layout_color [lrange $line 1 end]\n\
}\n\
}\n\
set line [gets $file]\n\
}\n\
close $file\n\
}\n\
\n\
NetworkModel instproc layout_node {line} {\n\
set color black\n\
set shape circle\n\
set src \"\"\n\
set size 0\n\
set addr 0	;# default\n\
for {set i 0} {$i < [llength $line]} {incr i} {\n\
set item [string range [lindex $line $i] 1 end]\n\
switch $item {\n\
\"s\" {\n\
set src [lindex $line [expr $i+1]]\n\
}\n\
\"v\" {\n\
set shape [lindex $line [expr $i+1]]\n\
}\n\
\"c\" {\n\
set color [lindex $line [expr $i+1]]\n\
}\n\
\"z\" {\n\
set size [lindex $line [expr $i+1]]\n\
}\n\
\"a\" {\n\
set addr [lindex $line [expr $i+1]]\n\
}\n\
\"x\" {\n\
set xcor [lindex $line [expr $i+1]]\n\
}\n\
\"y\" {\n\
set ycor [lindex $line [expr $i+1]]\n\
}\n\
}\n\
if {[string range $item 0 0]==\"-\"} {incr i}\n\
}\n\
if {$src==\"\"} {\n\
puts \"Error in parsing tracefile line:\\n$line\\n\"\n\
exit\n\
}\n\
\n\
if [info exists xcor] {\n\
$self node $src $shape $color $addr $size $xcor $ycor\n\
} else {\n\
$self node $src $shape $color $addr $size\n\
}\n\
}\n\
\n\
NetworkModel instproc layout_lan {line} {\n\
set name \"\"\n\
set rate \"\"\n\
set delay \"\"\n\
set orient down\n\
for {set i 0} {$i < [llength $line]} {incr i} {\n\
set item [string range [lindex $line $i] 1 end]\n\
switch $item {\n\
\"n\" {\n\
set name [lindex $line [expr $i+1]]\n\
}\n\
\"r\" {\n\
set rate [lindex $line [expr $i+1]]\n\
}\n\
\"D\" {\n\
set delay [lindex $line [expr $i+1]]\n\
}\n\
\"o\" {\n\
set orient [lindex $line [expr $i+1]]\n\
}\n\
}\n\
if {[string range $item 0 0]==\"-\"} {incr i}\n\
}\n\
if {$name==\"\"} {\n\
puts \"Error in parsing tracefile line:\\n$line\\n\"\n\
exit\n\
}\n\
set th [nam_angle $orient]\n\
$self lan $name [bw2real $rate] [time2real $delay] [expr $th]\n\
\n\
}\n\
\n\
NetworkModel instproc layout_link {line} {\n\
$self instvar delay01\n\
set orient right\n\
set src \"\"\n\
set dst \"\"\n\
set rate \"\"\n\
set delay \"\"\n\
set color \"\"\n\
set length 0\n\
for {set i 0} {$i < [llength $line]} {incr i} {\n\
set item [string range [lindex $line $i] 1 end]\n\
switch \"$item\" {\n\
\"s\" {\n\
set src [lindex $line [expr $i+1]]\n\
}\n\
\"d\" {\n\
set dst [lindex $line [expr $i+1]]\n\
}\n\
\"r\" {\n\
set rate [lindex $line [expr $i+1]]\n\
}\n\
\"D\" {\n\
set delay [lindex $line [expr $i+1]]\n\
}\n\
\"l\" {\n\
set length [lindex $line [expr $i+1]]\n\
}\n\
\"o\" {\n\
set orient [lindex $line [expr $i+1]]\n\
}\n\
\"c\" {\n\
set color [lindex $line [expr $i+1]]\n\
}\n\
}\n\
if {[string range $item 0 0]==\"-\"} {incr i}\n\
}\n\
if {($src==\"\")||($dst==\"\")||($rate==\"\")||($delay==\"\")} {\n\
puts \"Error in parsing tracefile line:\\n$line\\n\"\n\
exit\n\
}\n\
set th [nam_angle $orient]\n\
set rev [expr $th + 1]\n\
if { $rev > 2.0 } {\n\
set rev [expr $rev - 2.0]\n\
}\n\
$self link $dst $src [bw2real $rate] [time2real $delay] $length $rev\n\
set result [$self link $src $dst \\\n\
[bw2real $rate]  [time2real $delay] $length $th]\n\
if { $src == 0 && $dst == 1 } {\n\
set delay01 $result\n\
}\n\
\n\
if { $color!=\"\"} {\n\
$self ecolor $src $dst $color\n\
$self ecolor $dst $src $color\n\
}\n\
}\n\
\n\
NetworkModel instproc layout_lanlink {line} {\n\
$self instvar delay01\n\
set orient right\n\
set src \"\"\n\
set dst \"\"\n\
for {set i 0} {$i < [llength $line]} {incr i} {\n\
set item [string range [lindex $line $i] 1 end]\n\
switch \"$item\" {\n\
\"s\" {\n\
set src [lindex $line [expr $i+1]]\n\
}\n\
\"d\" {\n\
set dst [lindex $line [expr $i+1]]\n\
}\n\
\"o\" {\n\
set orient [lindex $line [expr $i+1]]\n\
}\n\
}\n\
if {[string range $item 0 0]==\"-\"} {incr i}\n\
}\n\
if {($src==\"\")||($dst==\"\")} {\n\
puts \"Error in parsing tracefile line:\\n$line\\n\"\n\
exit\n\
}\n\
set th [nam_angle $orient] ;# global function\n\
$self lanlink $dst $src $th\n\
}\n\
\n\
NetworkModel instproc layout_queue {line} {\n\
for {set i 0} {$i < [llength $line]} {incr i} {\n\
set item [string range [lindex $line $i] 1 end]\n\
switch $item {\n\
\"s\" {\n\
set src [lindex $line [expr $i+1]]\n\
}\n\
\"d\" {\n\
set dst [lindex $line [expr $i+1]]\n\
}\n\
\"a\" {\n\
set angle [lindex $line [expr $i+1]]\n\
}\n\
}\n\
if {[string range $item 0 0]==\"-\"} {incr i}\n\
}\n\
$self queue $src $dst $angle\n\
}\n\
\n\
NetworkModel instproc layout_color {line} {\n\
for {set i 0} {$i < [llength $line]} {incr i} {\n\
set item [string range [lindex $line $i] 1 end]\n\
switch $item {\n\
\"i\" {\n\
set ix [lindex $line [expr $i+1]]\n\
}\n\
\"n\" {\n\
set name [lindex $line [expr $i+1]]\n\
}\n\
}\n\
if {[string range $item 0 0]==\"-\"} {incr i}\n\
}\n\
$self color $ix $name\n\
}\n\
\n\
proc filesel {w dlg args} {\n\
frame $w -borderwidth 0\n\
set next \"\"\n\
set ctr 0\n\
foreach arg $args {\n\
if {[string range $arg 0 0]==\"-\"} {\n\
switch [string range $arg 1 end] {\n\
\"variable\" {\n\
set next variable\n\
}\n\
\"command\" {\n\
set next command\n\
}\n\
\"label\" {\n\
set next label\n\
}\n\
}\n\
} else {\n\
if {$next!=\"\"} {\n\
set vars($next) $arg\n\
}\n\
}\n\
}\n\
global $vars(variable)\n\
set $vars(variable) [pwd]\n\
frame $w.f0 -relief sunken -borderwidth 2\n\
listbox $w.f0.lb -width 50 -height 10 \\\n\
-yscroll \"$w.f0.sb set\" \\\n\
-selectforeground [resource activeForeground] \\\n\
-selectbackground [resource activeBackground] \\\n\
-highlightthickness 0\n\
scrollbar $w.f0.sb -command \"$w.f0.lb yview\" \\\n\
-highlightthickness 0\n\
pack $w.f0.lb -side left\n\
pack $w.f0.sb -side left -fill y\n\
pack $w.f0 -side top\n\
\n\
label $w.l2 -text $vars(label)\n\
pack $w.l2 -side top -anchor w\n\
\n\
entry $w.entry -width 50 -relief sunken\n\
bind $w.entry <Return> \\\n\
\"checkfile \\[set $vars(variable)\\] \\\"w\\\" $w $dlg \\\"$vars(command)\\\"\"\n\
$w.entry insert 0 [pwd]\n\
bind $w.entry <Delete> \\\n\
\"[bind Entry <BackSpace>];\\\n\
set $vars(variable) \\[$w.entry get\\];break\"\n\
bind $w.entry <BackSpace> \\\n\
\"[bind Entry <BackSpace>];\\\n\
set $vars(variable) \\[$w.entry get\\];break\"\n\
bind $w.entry <Key> \\\n\
\"[bind Entry <Key>];\\\n\
set $vars(variable) \\[$w.entry get\\];break\"\n\
bind $w.f0.lb <1> \"%W selection set \\[%W nearest %y\\];\\\n\
$w.entry delete 0 end;\\\n\
set $vars(variable) \\[pwd\\]/\\[%W get \\[%W nearest %y\\]\\]; \\\n\
$w.entry insert 0 \\[pwd\\]/\\[%W get \\[%W nearest %y\\]\\]\"\n\
bind $w.f0.lb <Double-Button-1> \\\n\
\"checkfile \\[set $vars(variable)\\] \\\"w\\\" $w $dlg \\\"$vars(command)\\\"\"\n\
pack $w.entry -side top -anchor w -fill x -expand true\n\
\n\
checkfile [pwd] \"r\" $w $dlg \"\"\n\
return $w\n\
}\n\
\n\
proc checkfile {file op w dlg cmd} {\n\
if {[file isdirectory $file]} {\n\
$w.entry delete 0 end\n\
cd $file\n\
$w.entry insert 0 [pwd]\n\
$w.f0.lb delete 0 end\n\
$w.f0.lb insert end ..\n\
foreach i [glob *] {\n\
$w.f0.lb insert end $i\n\
}\n\
} elseif {[file isfile $file]} {\n\
if {$op == \"r\"} {\n\
set flag [file readable $file]\n\
} else {\n\
set flag [file writable $file]\n\
}\n\
if $flag {\n\
eval $cmd\n\
destroy $dlg\n\
} else {\n\
errorpopup \"Error\" \"File $file is not writable\"\n\
}\n\
} else {\n\
set dirname [file dirname $file]\n\
set fname [file tail $file]\n\
if {$dirname != \"\"} {\n\
if [catch \"cd $dirname\"] {\n\
eval $cmd\n\
destroy $dlg\n\
}\n\
}\n\
set flist [glob -nocomplain $fname]\n\
$w.entry delete 0 end\n\
$w.entry insert 0 [pwd]\n\
$w.f0.lb delete 0 end\n\
if [llength $flist] {\n\
$w.f0.lb insert end ..\n\
foreach i $flist {\n\
$w.f0.lb insert end $i\n\
}\n\
} else {\n\
if {$op == \"w\"} {\n\
eval $cmd\n\
destroy $dlg\n\
} else {\n\
errorpopup \"Error\" \"File $file is not writable\"\n\
}\n\
}\n\
}\n\
}\n\
\n\
\n\
Animator instproc save_layout {} {\n\
$self instvar netModel tlw_\n\
$self tkvar savefile\n\
\n\
toplevel $tlw_.save\n\
set w $tlw_.save\n\
\n\
wm title $w \"Save layout\"\n\
frame $w.f -borderwidth 1 -relief raised\n\
pack $w.f -side top -fill both -expand true\n\
filesel $w.f.sel $w -variable [$self tkvarname savefile] \\\n\
-command \"$netModel savelayout \\[set [$self tkvarname savefile]\\]\" \\\n\
-label \"File to save to:\"\n\
pack $w.f.sel -side top -fill both -expand true\n\
frame $w.f.btns -borderwidth 0\n\
pack $w.f.btns -side top -fill x\n\
button $w.f.btns.save -text Save \\\n\
-command \"$self do_save_layout savefile $w.f.sel $w\"\n\
pack $w.f.btns.save -side left -fill x -expand true\n\
button $w.f.btns.cancel -text Cancel -command \"destroy $w\"\n\
pack $w.f.btns.cancel -side left -fill x -expand true\n\
set savefile [pwd]\n\
}\n\
\n\
Animator instproc do_save_layout {file w dlg} {\n\
$self instvar netModel\n\
$self tkvar $file\n\
set t $file\n\
puts \"save to file $t\"\n\
checkfile $t \"w\" $w $dlg \"$netModel savelayout $t\"\n\
}\n\
\n\
Animator instproc disablefile {w} {\n\
$w.entry configure -state disabled \\\n\
-foreground [option get . disabledForeground Nam]\n\
$w.l2 configure -foreground [option get . disabledForeground Nam]\n\
$w.f0.lb configure -foreground [option get . disabledForeground Nam]\n\
}\n\
\n\
Animator instproc normalfile {w filevar} {\n\
$self tkvar $filevar\n\
$w.entry configure -state normal \\\n\
-foreground [option get . foreground Nam]\n\
set $filevar [$w.entry get]\n\
$w.l2 configure -foreground [option get . foreground Nam]\n\
$w.f0.lb configure -foreground [option get . foreground Nam]\n\
}\n\
\n\
Animator instproc print_view { viewobject windowname } {\n\
$self tkvar printfile printto \n\
$self instvar tlw_	\n\
\n\
set p print\n\
\n\
if {[winfo exists $tlw_.$windowname-$p]} {\n\
puts \"Quit due to duplicate print view window!\"\n\
}\n\
\n\
\n\
toplevel $tlw_.$windowname-$p\n\
set w $tlw_.$windowname-$p\n\
wm title $w \"Print $windowname\"    \n\
\n\
frame $w.f -borderwidth 1 -relief raised\n\
pack $w.f -side top -fill both -expand true\n\
frame $w.f.f0 \n\
pack $w.f.f0 -side top -fill x\n\
label $w.f.f0.l -text \"Print to:\"\n\
pack $w.f.f0.l -side left\n\
\n\
$self tkvar printto\n\
radiobutton $w.f.f0.r1 -text \"Printer\" -variable [$self tkvarname printto] \\\n\
-value printer -command \"$self disablefile $w.f.sel;\\\n\
$w.f.f1.e configure -state normal -foreground \\\n\
[option get . foreground Nam];\\\n\
$w.f.f1.l configure -foreground [option get . foreground Nam];\\\n\
set [$self tkvarname printfile] \\[$w.f.f1.e get\\]\"\n\
pack $w.f.f0.r1 -side left \n\
radiobutton $w.f.f0.r2 -text \"File\" -variable [$self tkvarname printto] \\\n\
-value file -command \"$self normalfile $w.f.sel printfile;\\\n\
$w.f.f1.e configure -state disabled -foreground \\\n\
[option get . disabledForeground Nam];\\\n\
$w.f.f1.l configure -foreground \\\n\
[option get . disabledForeground Nam]\"\n\
pack $w.f.f0.r2 -side left \n\
frame $w.f.f1 \n\
pack $w.f.f1 -side top -fill x\n\
label $w.f.f1.l -text \"Print command:\"\n\
pack $w.f.f1.l -side left\n\
entry $w.f.f1.e \n\
pack $w.f.f1.e -side left -fill x -expand true\n\
bind $w.f.f1.e <Key> \"[bind Entry <Key>];\\\n\
set [$self tkvarname printfile] \\[$w.f.f1.e get\\];break\"\n\
bind $w.f.f1.e <Return> \\\n\
\"$self print_animation $viewobject $w\"\n\
set printer \"\"\n\
global env\n\
catch {set printer $env(PRINTER)}\n\
if {$printer!=\"\"} {\n\
$w.f.f1.e insert 0 \"lpr -P$printer \"\n\
} else {\n\
$w.f.f1.e insert 0 \"lpr \"\n\
}\n\
filesel $w.f.sel $w -variable [$self tkvarname printfile] \\\n\
-command \"$viewobject psview \\[set [$self tkvarname printfile]\\]\" \\\n\
-label \"File to save to:\"\n\
pack $w.f.sel -side top -fill both -expand true\n\
frame $w.f.btns -borderwidth 0\n\
pack $w.f.btns -side top -fill x\n\
button $w.f.btns.print -text Print \\\n\
-command \"$self print_animation $viewobject $w\"\n\
pack $w.f.btns.print -side left -fill x -expand true\n\
button $w.f.btns.cancel -text Cancel -command \"destroy $w\"\n\
pack $w.f.btns.cancel -side left -fill x -expand true\n\
\n\
set printto printer\n\
set printfile [$w.f.f1.e get]\n\
$self disablefile $w.f.sel\n\
}\n\
\n\
Animator instproc print_animation {viewobject w} {\n\
$self tkvar printto printfile\n\
\n\
if {$printto==\"file\"} {\n\
checkfile $printfile \"w\" $w.f.sel $w \\\n\
\"$viewobject psview $printfile\"\n\
} else {\n\
$viewobject psview /tmp/nam.ps\n\
puts [eval \"exec $printfile /tmp/nam.ps\"]\n\
catch {destroy $w}\n\
}\n\
}\n\
\n\
Animator instproc show_subtrees {} {\n\
$self instvar netModel\n\
$netModel showtrees\n\
}\n\
\n\
Animator instproc new_view {} {\n\
$self instvar netModel viewctr nam_name netViews tlw_\n\
\n\
toplevel $tlw_.v$viewctr\n\
set w $tlw_.v$viewctr\n\
\n\
incr viewctr\n\
wm title $w $nam_name\n\
frame $w.f\n\
frame $w.f.f -borderwidth 2 -relief sunken\n\
$netModel view $w.f.f.net\n\
set newView $w.f.f.net\n\
lappend netViews $newView\n\
pack $w.f.f.net -side top -expand true -fill both\n\
\n\
$newView xscroll $w.f.hsb\n\
scrollbar $w.f.hsb -orient horizontal -width 10 -borderwidth 1 \\\n\
-command \"$newView xview\"\n\
$w.f.hsb set 0.0 1.0\n\
pack $w.f.hsb -side bottom -fill x\n\
pack $w.f.f -side top -fill both -expand true\n\
\n\
frame $w.f2\n\
$newView yscroll $w.f2.vsb\n\
scrollbar $w.f2.vsb -orient vertical -width 10 -borderwidth 1 \\\n\
-command \"$newView yview\"\n\
$w.f2.vsb set 0.0 1.0\n\
pack $w.f2.vsb -side top -fill y -expand true\n\
frame $w.f2.l -width 12 -height 12\n\
pack $w.f2.l -side top\n\
\n\
frame $w.ctrl -borderwidth 2 -relief groove\n\
$self build-zoombar $newView $w.ctrl $w\n\
pack $w.ctrl -side left -fill y\n\
\n\
pack $w.f2 -side right -fill y\n\
pack $w.f -side left -fill both -expand true\n\
$self window_bind $w\n\
$self view_bind $newView\n\
}\n\
\n\
Animator instproc view_drag_start {view x y} {\n\
$self instvar drag\n\
set drag($view,x) $x\n\
set drag($view,y) $y\n\
}\n\
\n\
Animator instproc view_drag_motion {view x y} {\n\
$self instvar drag\n\
set dx [expr $drag($view,x) - $x]\n\
set dy [expr $drag($view,y) - $y]\n\
$view xview scroll $dx units\n\
$view yview scroll $dy units\n\
$self view_drag_start $view $x $y\n\
}\n\
\n\
Animator instproc new_editview {} {\n\
$self instvar netModel nam_name NETWORK_MODEL tlw_\n\
\n\
if [winfo exists $tlw_.editview] { \n\
return \n\
}\n\
toplevel $tlw_.editview\n\
set w $tlw_.editview\n\
\n\
wm title $w $nam_name\n\
frame $w.f\n\
frame $w.f.f -borderwidth 2 -relief sunken\n\
$netModel editview $w.f.f.edit\n\
set newView $w.f.f.edit\n\
pack $w.f.f.edit -side top -expand true -fill both\n\
\n\
$newView xscroll $w.f.hsb\n\
scrollbar $w.f.hsb -orient horizontal -width 10 -borderwidth 1 \\\n\
-command \"$newView xview\"\n\
$w.f.hsb set 0.0 1.0\n\
pack $w.f.hsb -side bottom -fill x\n\
pack $w.f.f -side top -fill both -expand true\n\
\n\
frame $w.f2\n\
$newView yscroll $w.f2.vsb\n\
scrollbar $w.f2.vsb -orient vertical -width 10 -borderwidth 1 \\\n\
-command \"$newView yview\"\n\
$w.f2.vsb set 0.0 1.0\n\
pack $w.f2.vsb -side top -fill y -expand true\n\
frame $w.f2.l -width 12 -height 12\n\
pack $w.f2.l -side top\n\
\n\
frame $w.ctrl -borderwidth 2 -relief groove\n\
$self build-zoombar $newView $w.ctrl $w\n\
pack $w.ctrl -side left -fill y\n\
\n\
pack $w.f2 -side right -fill y\n\
pack $w.f -side left -fill both -expand true\n\
\n\
editview_bind $w\n\
}\n\
\n\
proc editview_bind { w } {\n\
set ev $w.f.f.edit\n\
\n\
bind $ev <ButtonPress-1> \"$ev setPoint \\%x \\%y 0\"\n\
\n\
bind $ev <Shift-ButtonPress-1> \"$ev setPoint \\%x \\%y 1\"\n\
\n\
bind $ev <ButtonRelease-3> \"$ev dctag\"\n\
\n\
bind $ev <ButtonRelease-1> \"$ev relPoint \\%x \\%y\"\n\
\n\
bind $ev <Any-B1-Motion> \"$ev moveTo \\%x \\%y\"\n\
}\n\
\n\
\n\
set montab(l) graph\n\
set montab(n) \"\"\n\
set montab(p) monitor\n\
set montab(d) monitor\n\
set montab(r) monitor\n\
set montab(a) monitor\n\
\n\
Animator instproc graph_info { netView x y } {\n\
$self instvar running resume tracefile\n\
$self tkvar nowDisp\n\
catch {destroy $netView.f}\n\
frame $netView.f -relief groove -borderwidth 2\n\
set name [$netView getname $nowDisp $x $y]\n\
set type [lindex $name 0]\n\
switch $type {\n\
\"l\" {\n\
set e1 [lindex $name 1]\n\
set e2 [lindex $name 2]\n\
frame $netView.f.f1 -borderwidth 2 -relief groove\n\
pack $netView.f.f1 -side left\n\
label $netView.f.f1.l -text \"Graph bandwidth\" -font [smallfont]\n\
pack $netView.f.f1.l -side top\n\
frame $netView.f.f1.f -borderwidth 0\n\
pack $netView.f.f1.f -side top\n\
button $netView.f.f1.f.b2 -relief raised -highlightthickness 0 \\\n\
-text \"Link $e1->$e2\" -font [smallfont]\\\n\
-command \"$self end_info $netView;\\\n\
$self viewgraph \\\"l $e1 $e2\\\" bw $tracefile\"\n\
pack $netView.f.f1.f.b2 -side left -fill x -expand true\n\
button $netView.f.f1.f.b3 -relief raised -highlightthickness 0 \\\n\
-text \"Link $e2->$e1\" -font [smallfont] \\\n\
-command \"$self end_info $netView;\\\n\
$self viewgraph \\\"l $e2 $e1\\\" bw $tracefile\"\n\
pack $netView.f.f1.f.b3 -side left -fill x -expand true\n\
\n\
frame $netView.f.f2 -borderwidth 2 -relief groove\n\
pack $netView.f.f2 -side left\n\
label $netView.f.f2.l -text \"Graph loss\" -font [smallfont]\n\
pack $netView.f.f2.l -side top\n\
frame $netView.f.f2.f -borderwidth 0\n\
pack $netView.f.f2.f -side top\n\
button $netView.f.f2.f.b2 -relief raised -highlightthickness 0 \\\n\
-text \"Link $e1->$e2\" -font [smallfont]\\\n\
-command \"$self end_info $netView;\\\n\
$self viewgraph \\\"l $e1 $e2\\\" loss $tracefile\"\n\
pack $netView.f.f2.f.b2 -side left -fill x -expand true\n\
button $netView.f.f2.f.b3 -relief raised -highlightthickness 0 \\\n\
-text \"Link $e2->$e1\" -font [smallfont] \\\n\
-command \"$self end_info $netView;\\\n\
$self viewgraph \\\"l $e2 $e1\\\" loss $tracefile\"\n\
pack $netView.f.f2.f.b3 -side left -fill x -expand true\n\
}\n\
}\n\
button $netView.f.d -relief raised -highlightthickness 0 \\\n\
-text \"Dismiss\" -font [smallfont]\\\n\
-command \"$self end_info $netView\"\n\
pack $netView.f.d -side left  -anchor sw\n\
\n\
place_frame $netView $netView.f $x $y\n\
}\n\
\n\
Animator instproc start_info { netView x y key_} {\n\
$self instvar running resume tracefile \n\
$self tkvar nowDisp\n\
global montab\n\
\n\
if {($running)||([winfo exists $netView.f]&&($resume==1))} {\n\
set resume 1 \n\
} else {\n\
set resume 0\n\
}\n\
$self stop 1\n\
set text [string trim [$netView info $nowDisp $x $y] \"\\n\"]\n\
if { [string length $text] > 0 } {\n\
set name [$netView getname $nowDisp $x $y]\n\
set type [lindex $name 0]\n\
if {$type==\"\"} {\n\
puts \"got an empty object name returned from object $text!\"\n\
return\n\
}\n\
\n\
catch {destroy $netView.f}\n\
frame $netView.f -relief groove -borderwidth 2\n\
message $netView.f.msg -width 8c -text $text \\\n\
-font [option get . smallfont Nam]\n\
pack $netView.f.msg -side top\n\
frame $netView.f.f\n\
pack $netView.f.f -side top -fill x -expand true\n\
if {$montab($type)==\"monitor\"} {\n\
button $netView.f.f.b -relief raised -highlightthickness 0 \\\n\
-text \"Monitor\" \\\n\
-command \"$self monitor $netView $nowDisp $x $y; \\\n\
$self end_info $netView\"\n\
pack $netView.f.f.b -side left -fill x -expand true\n\
} elseif {$montab($type)==\"graph\"} {\n\
button $netView.f.f.b2 -relief raised -highlightthickness 0 \\\n\
-text \"Graph\" \\\n\
-command \"$self graph_info $netView $x $y\"\n\
pack $netView.f.f.b2 -side left -fill x -expand true\n\
}\n\
button $netView.f.f.d -relief raised -highlightthickness 0 \\\n\
-text \"Dismiss\" \\\n\
-command \"$self end_info $netView\"\n\
pack $netView.f.f.d -side left -fill x -expand true\n\
place_frame $netView $netView.f $x $y\n\
} else {\n\
$self end_info $netView\n\
}\n\
}\n\
\n\
Animator instproc end_info {netView} { \n\
$self instvar resume\n\
catch { destroy $netView.f }\n\
if $resume \"$self play 1\"\n\
}\n\
\n\
\n\
Animator instproc monitor {netView now x y} {\n\
$self instvar windows \n\
$self tkvar showpanel\n\
\n\
set mon [$netView new_monitor $now $x $y]\n\
set showpanel(monitor) 1\n\
if {$mon>=0} {\n\
$self create_monitor $netView $mon $now\n\
}\n\
}\n\
\n\
Animator instproc monitor_agent {node agent} {\n\
$self instvar netViews netModel \n\
$self tkvar nowDisp showpanel\n\
\n\
set netView [lindex $netViews 0]\n\
set mon [$netModel new_monitor_agent $node $agent]\n\
set showpanel(monitor) 1\n\
if {$mon>=0} {\n\
$self create_monitor $netView $mon $nowDisp\n\
}\n\
}\n\
\n\
Animator instproc create_monitor {netView mon now} {\n\
$self instvar windows monitors maxmon\n\
frame $windows(monitor).f$maxmon -borderwidth 2 -relief groove\n\
pack $windows(monitor).f$maxmon -side left -fill y\n\
set monitors($mon) $windows(monitor).f$maxmon\n\
set w $windows(monitor).f$maxmon\n\
message $w.l -aspect 300 -text \"\\[$mon\\] [$netView monitor $now $mon]\" \\\n\
-anchor nw -font [option get . smallfont Nam]\n\
pack $w.l -side top -anchor w -fill both -expand true\n\
bind $w.l <Enter> \\\n\
\"$w.l configure -background [option get . activeBackground Nam]\"\n\
bind $w.l <Leave> \\\n\
\"$w.l configure -background [option get . background Nam]\"\n\
bind $w.l <1> \"$self delete_monitor $netView $mon\"\n\
incr maxmon\n\
}\n\
\n\
Animator instproc update_monitors {netView now} {\n\
$self instvar monitors\n\
foreach mon [array names monitors] {\n\
set text [$netView monitor $now $mon]\n\
if {$text==\"\"} {\n\
$self delete_monitor $netView $mon\n\
} else {\n\
set text \"\\[$mon\\] $text\"\n\
if {[$monitors($mon).l configure -text]!=$text} {\n\
$monitors($mon).l configure -text \"$text\"\n\
}\n\
}\n\
}\n\
}\n\
\n\
Animator instproc delete_monitor {netView mon} {\n\
$self instvar monitors\n\
$netView delete_monitor $mon\n\
catch {destroy $monitors($mon)}\n\
unset monitors($mon)\n\
$self redrawFrame\n\
}\n\
\n\
set stackthese \"h1 h2 h3 h4 h5 h6 b i ul ol dl a pre\"\n\
set www_cancels(/h1) \"h1 h2 h3 h4 h5 h6 i b\"\n\
set www_cancels(/h2) \"h1 h2 h3 h4 h5 h6 i b\"\n\
set www_cancels(/h3) \"h1 h2 h3 h4 h5 h6 i b\"\n\
set www_cancels(/h4) \"h1 h2 h3 h4 h5 h6 i b\"\n\
set www_cancels(/h5) \"h1 h2 h3 h4 h5 h6 i b\"\n\
set www_cancels(/h6) \"h1 h2 h3 h4 h5 h6 i b\"\n\
set www_cancels(h1) \"h1 h2 h3 h4 h5 h6 i b\"\n\
set www_cancels(h2) \"h1 h2 h3 h4 h5 h6 i b\"\n\
set www_cancels(h3) \"h1 h2 h3 h4 h5 h6 i b\"\n\
set www_cancels(h4) \"h1 h2 h3 h4 h5 h6 i b\"\n\
set www_cancels(h5) \"h1 h2 h3 h4 h5 h6 i b\"\n\
set www_cancels(h6) \"h1 h2 h3 h4 h5 h6 i b\"\n\
set www_cancels(/b) \"b\"\n\
set www_cancels(/strong) \"strong\"\n\
set www_cancels(/i) \"i\"\n\
set www_cancels(/ul) \"ul\"\n\
set www_cancels(/ol) \"ol\"\n\
set www_cancels(/dl) \"dl\"\n\
set www_cancels(/a) \"a\"\n\
set www_cancels(/pre) \"pre\"\n\
set www_sets(h1) {{bold 1} {size 18}}\n\
set www_sets(h2) {{bold 1} {size 14}} ;# may not exists on some systems\n\
set www_sets(h3) {{bold 1} {size 14}}\n\
set www_sets(h4) {{bold 1} {size 12}}\n\
set www_sets(h5) {{bold 1} {size 10}}\n\
set www_sets(h6) {{bold 1} {size 10}}\n\
set www_sets(i) {{italic 1} {bold 0}}\n\
set www_sets(b) {{italic 0} {bold 1}}\n\
set www_sets(strong) {{italic 0} {bold 1}}\n\
set www_sets(verbatim) {{verbatim 1} {font courier}}\n\
set www_sets(normal) {{bold 0} {italic 0} {font helvetica} {size 12} {nl 0} {hr 0} {ltype \"\"} {bullet 0} {verbatim 0} {indent 0} {href \"\"}}\n\
set www_sets(ul) {{ltype ul} {indent [expr $indent+4]}}\n\
set www_sets(ol) {{ltype ol} {indent [expr $indent+4]}}\n\
set www_sets(dl) {{ltype dl} {indent [expr $indent+4]}}\n\
set www_sets(a) {{href XXX}}\n\
set www_runs(a) {extract_anchor}\n\
set www_runs(img) {extract_image}\n\
\n\
set www_fsets(p) {{nl 2}}\n\
set www_fsets(br) {{nl 1}}\n\
set www_fsets(hr) {{hr 1}}\n\
set www_fsets(h1) {{nl 2}}\n\
set www_fsets(h2) {{nl 2}}\n\
set www_fsets(h3) {{nl 2}}\n\
set www_fsets(h4) {{nl 2}}\n\
set www_fsets(h5) {{nl 2}}\n\
set www_fsets(h6) {{nl 2}}\n\
set www_fsets(ul) {{nl 0}}\n\
set www_fsets(ol) {{nl 0}}\n\
set www_fsets(dl) {{nl 0}}\n\
set www_fsets(/h1) {{nl 2}}\n\
set www_fsets(/h2) {{nl 2}}\n\
set www_fsets(/h3) {{nl 2}}\n\
set www_fsets(/h4) {{nl 2}}\n\
set www_fsets(/h5) {{nl 2}}\n\
set www_fsets(/h6) {{nl 2}}\n\
set www_fsets(/ul) {{nl 1}}\n\
set www_fsets(/ol) {{nl 1}}\n\
set www_fsets(/dl) {{nl 1}}\n\
set www_fsets(li) {{nl 1} {bullet 1}}\n\
set www_fsets(dt) {{nl 1}}\n\
\n\
set fonts(normal) -*-helvetica-medium-r-normal--12-*\n\
set fonts(helvetica,0,0,16) -*-helvetica-medium-r-normal--17-*\n\
set fonts(helvetica,1,0,16) -*-helvetica-bold-r-normal--17-*\n\
set fonts(helvetica,1,1,16) -*-helvetica-bold-o-normal--17-*\n\
set fonts(helvetica,1,0,18) -*-helvetica-bold-r-normal--18-*\n\
set fonts(helvetica,1,1,18) -*-helvetica-bold-o-normal--18-*\n\
set fonts(helvetica,1,0,14) -*-helvetica-bold-r-normal--14-*\n\
set fonts(helvetica,1,1,14) -*-helvetica-bold-o-normal--14-*\n\
set fonts(helvetica,1,0,12) -*-helvetica-bold-r-normal--12-*\n\
set fonts(helvetica,1,1,12) -*-helvetica-bold-o-normal--12-*\n\
set fonts(helvetica,0,1,12) -*-helvetica-medium-o-normal--12-*\n\
set fonts(helvetica,1,0,10) -*-helvetica-bold-r-normal--10-*\n\
\n\
AnimControl instproc parse_html {w entry text} {\n\
global www_sets www_fsets www_cancels www_runs stackthese fonts \n\
$self instvar href href_keep www_win\n\
set www_win $w\n\
set stack normal\n\
set size normal\n\
set font helvetica\n\
set bold 0\n\
set italic 0\n\
set underline 0\n\
set verbatim 0\n\
set indent 0\n\
set nl 0\n\
set hr 0\n\
set prevnl 0\n\
set href \"\"\n\
set bullet 0\n\
set ltype \"\"\n\
set parts [split $text \"<>\"]\n\
set istag 0\n\
$w delete 1.0 end\n\
foreach part $parts {\n\
if {$istag==1} {\n\
set tag [string tolower [lindex $part 0]]\n\
set c \"\"\n\
catch {set c $www_cancels($tag)}\n\
set rm 0\n\
set newstack {}\n\
foreach frame $stack {\n\
set newframe {}\n\
if {([lsearch -exact $c $frame]>=0)&&($rm==0)} {\n\
set rm 1\n\
} else {\n\
lappend newstack $frame\n\
}\n\
}\n\
set stack $newstack\n\
set newframe $tag\n\
\n\
foreach frame \"$stack $newframe\" {\n\
set t [lindex $frame 0]\n\
set s \"\"\n\
catch {set s $www_sets($t)}\n\
foreach item $s {\n\
set cmd \"set $item\"\n\
eval $cmd\n\
}\n\
}\n\
\n\
set s \"\"\n\
catch {set s $www_fsets($tag)}\n\
foreach item $s {\n\
set cmd \"set $item\"\n\
eval $cmd\n\
}\n\
\n\
set s \"\"\n\
catch {set s $www_runs($tag)}\n\
foreach item $s {\n\
set cmd \"$self $item $part\"\n\
eval $cmd\n\
}\n\
\n\
if {[lsearch -exact $stackthese $tag]>=0} {\n\
lappend stack $newframe\n\
}\n\
\n\
} else {\n\
if {$hr==1} {\n\
$w insert end \"\\n_____________________________________________________\\n\"\n\
if {$prevnl==0} {set prevnl 1}\n\
}\n\
\n\
for {set i 0} {$i < [expr $nl-$prevnl]} {incr i} {\n\
$w insert end \"\\n\"\n\
}\n\
set prevnl $nl\n\
\n\
if {$nl>0} {\n\
for {set i 0} {$i < $indent} {incr i} {\n\
$w insert end \" \"\n\
}\n\
}\n\
\n\
if {$bullet!=0} {\n\
$w insert end \"* \"\n\
}\n\
\n\
set ix [$w index end-1c]\n\
if {$nl>0} {\n\
set part [string trimleft $part]\n\
}\n\
if {$verbatim==0} {\n\
set part [remove_nl $part]\n\
if {[string length $part]>0} {\n\
set prevnl 0\n\
}\n\
$w insert end $part\n\
} else {\n\
$w insert end $part\n\
}\n\
\n\
$self instvar tagnum\n\
if {($size!=12)||($bold==1)||($italic==1)||($href!=\"\")||\\\n\
($font!=\"helvetica\")} {\n\
incr tagnum\n\
set ix2 [$w index end-1c]\n\
$w tag add t$tagnum $ix end-1c\n\
}\n\
if {($size!=12)||($bold==1)||($italic==1)||\\\n\
($font!=\"helvetica\")} {\n\
set thisfont $fonts(normal)\n\
catch {\n\
set thisfont $fonts($font,$bold,$italic,$size)\n\
}\n\
$w tag configure t$tagnum -font $thisfont\n\
}\n\
if {$href!=\"\"} {\n\
$w tag configure t$tagnum -foreground red\n\
$w tag bind t$tagnum <Enter> \\\n\
\"$self set_entry $entry $href_keep\"\n\
$w tag bind t$tagnum <Leave> \\\n\
\"$self set_entry $entry {}\"\n\
$w tag bind t$tagnum <1> \"$self goto $href_keep $w $entry\"\n\
}\n\
\n\
}\n\
set istag [expr 1-$istag]\n\
}\n\
}\n\
\n\
AnimControl instproc set_entry {entry str} {\n\
$entry delete 0 end\n\
$entry insert 0 $str\n\
}\n\
\n\
AnimControl instproc extract_anchor args {\n\
$self instvar href_keep href\n\
set href_keep \"\"\n\
set href \"\"\n\
foreach arg $args {\n\
if {[string range [string tolower $arg] 0 4]==\"href=\"} {\n\
set href_keep [string trim [string range $arg 5 end] {\"}]\n\
set href XXX\n\
}	    \n\
}\n\
}\n\
\n\
AnimControl instproc extract_image args {\n\
$self instvar www_win wix\n\
set img \"\"\n\
foreach arg $args {\n\
if {[string range [string tolower $arg] 0 3]==\"src=\"} {\n\
set img [string trim [string range $arg 4 end] {\"}]\n\
}	    \n\
}\n\
$www_win window create end -create \"label $www_win.w$wix -bitmap $img\"\n\
incr wix\n\
}\n\
\n\
AnimControl instproc goto {url win entry} {\n\
global help_text\n\
set res \"xxxx\"\n\
set scheme [lindex [split $url \":\"] 0]\n\
if {$scheme==\"help\"} {\n\
$self parse_html $win $entry $help_text([string range $url 5 end])\n\
return\n\
}\n\
set proggy netscape\n\
catch {\n\
set res [exec $proggy -display :0 -remote openURL($url)]\n\
}\n\
if {$res==\"xxxx\"} {\n\
catch {\n\
set res [exec $proggy -display :0.1 -remote openURL($url)]\n\
}\n\
}\n\
if {$res==\"xxxx\"} {\n\
puts \"failed to pass URL to $proggy\"\n\
}\n\
}\n\
\n\
proc lreverse {list} {\n\
set res {}\n\
foreach el $list {\n\
set res [concat [list $el] $res]\n\
}\n\
return $res\n\
}\n\
\n\
proc remove_nl {str} {\n\
set parts [split $str \"\\n\\r\"] \n\
set res \"\"\n\
set space 1\n\
for {set i 0} {$i<[llength $parts]} {incr i} {\n\
set part [lindex $parts $i]\n\
if {$i>0} {\n\
set part [string trimleft $part]\n\
} else {\n\
if {$part==\"\"} {set space 0}\n\
}\n\
if {($i+1)<[llength $parts]} {\n\
set part [string trimright $part]\n\
}\n\
if {$space==0} {\n\
set res \"$res \"\n\
set space 1\n\
} \n\
if {[string length $part] > 0} {\n\
set res \"$res$part\"\n\
set space 0\n\
}\n\
}\n\
return $res\n\
}\n\
\n\
\n\
set help_text(about) \"<h1>VINT/UCB Network Animator (nam)</h1>\n\
This version of nam is highly experimental - there will be bugs!.  \n\
Please mail <I><a href=mailto:ns-developers@mash.cs.berkeley.edu>ns-developers@mash.cs.berkeley.edu</a></I> if you \n\
encounter any bugs, or with suggestions for desired functionality.\n\
<H2>History</h2>\n\
The network animator ``nam''\n\
began in 1990 as a simple tool for animating packet trace data.\n\
This trace data is typically\n\
derived as output from a network simulator like\n\
<a href=http://www-mash.cs.berkeley.edu/ns/>ns</a>\n\
or from real network measurements, e.g., using\n\
<a href=ftp://ftp.ee.lbl.gov/tcpdump.tar.Z>tcpdump</a>.\n\
<a href=http://www.cs.berkeley.edu/~mccanne>Steven McCanne</a>\n\
wrote the original version as a member of the\n\
<a href=http://www-nrg.ee.lbl.gov/>Network Research Group</a> at the\n\
<a href=http://www.lbl.gov/>Lawrence Berkeley National Laboratory</a>,\n\
and occasionally improved the design as he needed it in\n\
his research.  Marylou Orayani improved it further and used it\n\
for her Master's research over summer 1995 and into spring 1996.\n\
The nam development effort is now an ongoing\n\
collaboration with the\n\
<a href=http://netweb.usc.edu/vint/>VINT project</a>.\n\
Current nam developers include\n\
<a href=http://north.east.isi.edu/~mjh/>Mark Handley</a>, \n\
<a href=http://www.isi.edu/~haoboy/>Haobo Yu</a> and <a href=http://www.isi.edu/~johnh/>John Heidemann</a>.\n\
<P>\n\
For information about ns and nam, please see\n\
<i><a href=http://mash-www.cs.berkeley.edu/ns/nam.html>http://mash-www.cs.berkeley.edu/ns/nam.html</a></i>.\n\
<h2>Funding</h2>\n\
Nam is currently funded by DARPA through the VINT project at LBL under\n\
DARPA grant DABT63-96-C-0105, at USC/ISI under DARPA grant\n\
ABT63-96-C-0054, at Xerox PARC under DARPA grant DABT63-96-C-0105. \n\
<H2>Copyright</H2>\n\
Nam contains source code with the following copyrights:\n\
<p>\n\
Copyright (c) 1991-1994 Regents of the University of California.\n\
<br>\n\
Copyright (c) 1997 University of Southern California\n\
<P>\n\
<hr>\n\
<i><a href=help:help>Help Index</a><I>\n\
\"\n\
\n\
set help_text(help) \"\n\
<H1>Nam Quick Help</H1>\n\
<B>Use the controls to move the animation through time:</B>\n\
<DL>\n\
<DT><img src=rew>Rewind the animation by 0.05 seconds\n\
<DT><img src=back>Play the animation backwards\n\
<DT><img src=stop>Stop the playing of the animation\n\
<DT><img src=play>Play the animation normally\n\
<DT><img src=ff>Fast forward the animation by 0.05 seconds\n\
<DT><img src=eject>Exit nam\n\
</DL>\n\
<P>\n\
When the animation is running\n\
<UL><LI>Click the left button on an object in the display window to view information about that object.\n\
<LI>Select \\\"monitor\\\" from the resulting popup window to <a href=help:monitors>monitor that object</a> over time.\n\
<LI>The \\\"step\\\" slider can be used to control how fast time flows in the animation.\n\
The \\\"time\\\" slider can be used to move to a specific point in time.\n\
</UL>\n\
<P>\n\
<hr>\n\
<i><a href=help:about>About Nam</a><I>\n\
\"\n\
\n\
set help_text(monitors) \"\n\
<H1>Nam Help: Monitors</H1>\n\
You can set monitors on various animation objects to examine \n\
information about them over time.\n\
<H2>Packet Monitors</H2>\n\
To initiate a packet monitor, click the left button on the packet \n\
you wish to examine.  Information that nam has about that packet \n\
will then be displayed, and you are given the option to set a \n\
monitor on the packet.\n\
<P>\n\
Setting a monitor on a packet labels the packet so that you can \n\
more easily watch its flow through the network and through queues.\n\
An associated panel appears in the monitors window listing information \n\
about the packet if the packet is visible.  \n\
<P>\n\
Click on the monitor panel for a packet to remove that monitor.\n\
<H2>Agent Monitors</H2>\n\
Protocol agents are displayed alongside the node they are \n\
instantiated in.  To monitor an agent, click on it in the \n\
network display, and select \\\"monitor\\\".\n\
Information about the agent will be displayed in the monitors \n\
panel, and will be updated as protocol state in the agent \n\
changes over time.\n\
<P>\n\
Click on the monitor panel for the agent to remove that monitor.\n\
<hr>\n\
<I><a href=help:help>Return to help index</a>\n\
\"\n\
\n\
AnimControl instproc new_web {which} {\n\
global help_text\n\
if {[winfo exists .help]} {\n\
$self parse_html .help.f.f.w .help.f.ctl.e $help_text($which)\n\
return\n\
}\n\
toplevel .help\n\
wm title  .help \"About nam\"\n\
frame .help.f -relief groove -borderwidth 2\n\
pack  .help.f -side top -fill both -expand true\n\
frame .help.f.f\n\
pack  .help.f.f -side top -fill both -expand true\n\
text .help.f.f.w -width 60 -height 40 -wrap word -yscroll \".help.f.f.sb set\"\n\
bind .help.f.f.w <1> break\n\
pack .help.f.f.w -side left -fill both -expand true\n\
scrollbar .help.f.f.sb -command \".help.f.f.w yview\"\n\
pack .help.f.f.sb -side right -fill y\n\
frame .help.f.ctl -borderwidth 2 -relief groove\n\
pack .help.f.ctl -side top -fill x\n\
label .help.f.ctl.l -text \"go to:\"\n\
pack .help.f.ctl.l -side left\n\
entry .help.f.ctl.e -width 20 -borderwidth 1 -relief sunken\n\
pack .help.f.ctl.e -side left -fill x -expand true\n\
button .help.f.ctl.b -borderwidth 1 -relief raised -text Dismiss \\\n\
-command {destroy .help}\n\
pack .help.f.ctl.b -side left\n\
$self parse_html .help.f.f.w .help.f.ctl.e $help_text($which)\n\
}\n\
\n\
Animator instproc build-ui {} {\n\
$self instvar netView id_ tlw_ \n\
\n\
set tlw_ .model$id_\n\
toplevel $tlw_\n\
\n\
frame $tlw_.menu -borderwidth 0\n\
$self build-menus $tlw_.menu\n\
pack $tlw_.menu -side top -fill x\n\
\n\
frame $tlw_.view\n\
$self build-view $tlw_.view\n\
\n\
frame $tlw_.ctrl0 -relief flat -borderwidth 0\n\
$self build-animation-ctrl $tlw_.ctrl0 \n\
pack $tlw_.ctrl0 -side top -fill x\n\
\n\
frame $tlw_.ctrl -relief flat -borderwidth 0\n\
$self build-view-ctrl $tlw_.ctrl\n\
set windows(control) $tlw_.ctrl\n\
pack $tlw_.ctrl -side bottom -fill x\n\
\n\
pack $tlw_.view -side top -fill both -expand true\n\
\n\
wm minsize $tlw_ 200 200\n\
$self window_bind $tlw_\n\
$self view_bind $netView\n\
\n\
$self instvar tracefile\n\
wm title $tlw_ \"[tk appname]: $tracefile\"\n\
}\n\
\n\
Animator instproc build-view w {\n\
$self tkvar showpanel\n\
$self instvar netModel netView netViews tlw_ windows\n\
\n\
frame $w.f\n\
frame $w.f.f -borderwidth 2 -relief sunken\n\
$netModel view $w.f.f.net\n\
set netView $w.f.f.net\n\
set netViews $netView\n\
pack $w.f.f.net -side top -expand true -fill both\n\
\n\
$netView xscroll $w.f.hsb\n\
scrollbar $w.f.hsb -orient horizontal -width 10 \\\n\
-borderwidth 1 -command \"$netView xview\"\n\
$w.f.hsb set 0.0 1.0\n\
pack $w.f.hsb -side bottom -fill x\n\
pack $w.f.f -side top -fill both -expand true\n\
\n\
frame $w.f2\n\
$netView yscroll $w.f2.vsb\n\
scrollbar $w.f2.vsb -orient vertical -width 10 \\\n\
-borderwidth 1 -command \"$netView yview\"\n\
$w.f2.vsb set 0.0 1.0\n\
pack $w.f2.vsb -side top -fill y -expand true\n\
frame $w.f2.l -width 12 -height 12\n\
pack $w.f2.l -side top\n\
\n\
frame $w.ctrl -borderwidth 2 -relief groove\n\
$self build-zoombar $netView $w.ctrl $w\n\
pack $w.ctrl -side left -fill y\n\
pack $w.f2 -side right -fill y\n\
pack $w.f -side left -fill both -expand true\n\
\n\
frame $tlw_.monwin -relief groove -borderwidth 2\n\
button $tlw_.monwin.l -bitmap monitors -borderwidth 2 -relief groove \\\n\
-command \"$self closepanel monitor\"\n\
pack $tlw_.monwin.l -side left -fill y\n\
set windows(monitor) $tlw_.monwin\n\
trace variable showpanel(monitor) w \\\n\
\"$self displaypanel $tlw_.monwin $w monitor top x false\"\n\
set showpanel(monitor) 0\n\
}\n\
\n\
Animator instproc build-view-ctrl {w} {\n\
$self tkvar showpanel\n\
$self instvar NETWORK_MODEL\n\
\n\
frame $w.p0b -relief flat -borderwidth 0\n\
$self build-slider $w.p0b\n\
\n\
frame $w.tl -relief flat -borderwidth 0\n\
$self build-annotation $w.tl\n\
set showpanel(annotate) 1\n\
\n\
if {$NETWORK_MODEL == \"NetworkModel/Auto\"} {\n\
set showpanel(autolayout) 1\n\
trace variable showpanel(autolayout) w \\\n\
\"$self displaypanel $w.p2 $w.p0b autolayout \\\n\
top x false\"\n\
frame $w.p2 -relief flat -borderwidth 0\n\
$self build-layout $w.p2\n\
pack $w.p0b $w.p2 $w.tl  \\\n\
-side top -fill x\n\
} else {\n\
set showpanel(autolayout) 0\n\
pack $w.p0b $w.tl -side top -fill x\n\
}\n\
}\n\
\n\
Animator instproc build-menus w {\n\
$self tkvar nam_record_animation nam_auto_ff showpanel isSync_\n\
$self instvar NETWORK_MODEL netModel nam_name windows \n\
\n\
frame $w.menu -relief groove -bd 2\n\
pack $w.menu -side top -fill x\n\
\n\
set padx 4\n\
\n\
set mb $w.menu.file\n\
set m $mb.m\n\
menubutton $mb -text \"File\" -menu $m -underline 0 \\\n\
-borderwidth 1 \n\
menu $m\n\
$m add command -label \"Save layout\" -command \"$self save_layout\"\n\
$m add command -label \"Print\" -command \"$self print_view $netModel nam\"\n\
$m add separator\n\
$m add checkbutton -label \"Record animation\" \\\n\
-variable [$self tkvarname nam_record_animation]\n\
if ![info exists nam_record_animation] {\n\
set nam_record_animation 0\n\
}\n\
$m add checkbutton -label \"Auto FastForward\" \\\n\
-variable [$self tkvarname nam_auto_ff]\n\
if ![info exists nam_auto_ff] {\n\
set nam_auto_ff 0\n\
}\n\
\n\
$m add separator\n\
$m add command -label \"Quit\" -command \"$self done\"\n\
pack $mb -side left -padx $padx\n\
\n\
set mb $w.menu.views\n\
set m $mb.m\n\
menubutton $mb -text \"Views\" -menu $m -underline 0 \\\n\
-borderwidth 1 \n\
menu $m\n\
$m add command -label \"New view\" -command \"$self new_view\"\n\
$m add command -label \"Edit view\" -command \"$self new_editview\"\n\
$m add separator\n\
$m add command -label \"Highlight leaf trees\" -command \\\n\
\"$self show_subtrees\"\n\
$m add checkbutton -label \"Show monitors\" \\\n\
-variable [$self tkvarname showpanel(monitor)]\n\
if {$NETWORK_MODEL==\"NetworkModel/Auto\"} {\n\
$m add checkbutton -label \"Show autolayout\" \\\n\
-variable [$self tkvarname showpanel(autolayout)]\n\
} else {\n\
$m add checkbutton -label \"Show autolayout\" -state disabled\n\
}\n\
$m add checkbutton -label \"Show annotations\" \\\n\
-variable [$self tkvarname showpanel(annotate)]\n\
$m add checkbutton -label \"Sync\" \\\n\
-variable [$self tkvarname isSync_]\n\
if ![info exists isSync_] {\n\
set isSync_ 0\n\
}\n\
trace variable isSync_ w \"$self on-change-sync\"\n\
pack $mb -side left -padx $padx\n\
\n\
set mb $w.menu.analysis\n\
set m $mb.m\n\
$self instvar analysis_OK\n\
if { $analysis_OK == 0 } {\n\
menubutton $mb -text \"Analysis\" -menu $m -underline 0 \\\n\
-borderwidth 1 -state disabled\n\
} else {\n\
menubutton $mb -text \"Analysis\" -menu $m -underline 0 \\\n\
-borderwidth 1\n\
}\n\
\n\
menu $m\n\
$m add command -label \"Active Sessions\" -command \"$self active_sessions\"\n\
$m add command -label \"Legend ...\" -command \"$self auto_legend\"\n\
pack $mb -side left -padx $padx\n\
\n\
label $w.menu.name -text $nam_name -font [smallfont] \\\n\
-width 30 -borderwidth 2 -relief groove \n\
set windows(title) $w.menu.name\n\
pack $w.menu.name -side left -fill x -expand true -padx 4 -pady 1\n\
\n\
}\n\
\n\
Animator instproc on-change-sync args {\n\
$self tkvar isSync_\n\
if $isSync_ {\n\
$self add-sync $self\n\
} else {\n\
$self remove-sync $self\n\
}\n\
}\n\
\n\
Animator instproc set_run { w } {\n\
$self instvar netView running\n\
focus $netView\n\
$self set_forward_dir 1\n\
if { $running != 1 } {\n\
$self play 1\n\
}\n\
$self highlight $w.bar.run 1\n\
}\n\
\n\
Animator instproc set_back { w } {\n\
$self instvar netView running\n\
focus $netView\n\
$self set_backward_dir 1\n\
if { $running != 1 } {\n\
$self play 1\n\
$self renderFrame\n\
}\n\
$self highlight $w.bar.back 1\n\
}\n\
\n\
Animator instproc on-rateslider-press {} {\n\
$self instvar currRate prevRate\n\
set prevRate $currRate\n\
}\n\
\n\
Animator instproc on-rateslider-motion { v } {\n\
$self instvar timeStep stepDisp\n\
set timeStep [expr pow(10, $v / 10.)]\n\
set stepDisp [step_format $timeStep]\n\
}\n\
\n\
Animator instproc build-animation-ctrl {w} {\n\
$self instvar rateSlider granularity timeStep currRate prevRate \\\n\
stepDisp running direction \n\
\n\
set f [smallfont]\n\
frame $w.bar -relief groove -borderwidth 2\n\
frame $w.bar.rate -borderwidth 1 -relief sunken\n\
scale $w.bar.rate.s -orient horizontal -width 7p \\\n\
-label \"Step:\" -font [smallfont]\\\n\
-from -60 -to -1 -showvalue false \\\n\
-relief flat\\\n\
-borderwidth 1 -highlightthickness 0 \\\n\
-troughcolor [option get . background Nam]\n\
pack $w.bar.rate.s -side top -fill both -expand true\n\
set rateSlider $w.bar.rate.s\n\
set granularity [option get . granularity Nam]\n\
set timeStep [time2real [option get . rate Nam]]\n\
set stepDisp [step_format $timeStep]\n\
set currRate [expr 10*log10($timeStep)]\n\
set prevRate $currRate\n\
$rateSlider set $currRate\n\
bind $rateSlider <ButtonRelease-1> \"$self set_rate \\[%W get\\] 1\"\n\
bind $rateSlider <ButtonPress-1> \"$self on-rateslider-press\"\n\
bind $rateSlider <B1-Motion> \"$self on-rateslider-motion \\[%W get\\]\"\n\
trace variable stepDisp w \"$self displayStep\"\n\
\n\
$self tkvar nowDisp\n\
label $w.bar.timerVal -textvariable [$self tkvarname nowDisp] \\\n\
-width 14 -anchor w -font $f -borderwidth 1 \\\n\
-relief sunken -anchor e\n\
\n\
frame $w.bar.run\n\
button $w.bar.run.b -bitmap play -borderwidth 1 -relief raised \\\n\
-highlightthickness 0 -font $f  \\\n\
-command \"$self set_run $w\"\n\
frame $w.bar.run.f -height 5 -relief sunken \\\n\
-borderwidth 1\n\
pack $w.bar.run.b -side top -fill both -expand true\n\
pack $w.bar.run.f -side top -fill x\n\
\n\
frame $w.bar.back\n\
button $w.bar.back.b -bitmap back -borderwidth 1 -relief raised \\\n\
-highlightthickness 0 -font $f \\\n\
-command \"$self set_back $w\"\n\
\n\
trace variable running w \"$self trace_running_handler $w\"\n\
\n\
frame $w.bar.back.f -height 5 -relief sunken \\\n\
-borderwidth 1\n\
pack $w.bar.back.b -side top -fill both -expand true\n\
pack $w.bar.back.f -side top -fill x\n\
\n\
frame $w.bar.stop\n\
button $w.bar.stop.b -bitmap stop -borderwidth 1 -relief raised \\\n\
-highlightthickness 0 -font $f \\\n\
-command \"$self stop 1;\\\n\
$self renderFrame;\\\n\
$self highlight $w.bar.stop 1\"\n\
frame $w.bar.stop.f -height 5 -relief sunken \\\n\
-borderwidth 1\n\
pack $w.bar.stop.b -side top -fill both -expand true\n\
pack $w.bar.stop.f -side top -fill x\n\
\n\
frame $w.bar.rew\n\
button $w.bar.rew.b -bitmap rew -borderwidth 1 -relief raised \\\n\
-highlightthickness 0 -font $f -command \"$self rewind\"\n\
frame $w.bar.rew.f -height 5 -relief sunken \\\n\
-borderwidth 1\n\
pack $w.bar.rew.b -side top -fill both -expand true\n\
pack $w.bar.rew.f -side top -fill x\n\
\n\
frame $w.bar.ff\n\
button $w.bar.ff.b -bitmap ff -borderwidth 1 -relief raised \\\n\
-highlightthickness 0 -font $f -command \"$self fast_fwd\"\n\
frame $w.bar.ff.f -height 5 -relief sunken \\\n\
-borderwidth 1\n\
pack $w.bar.ff.b -side top -fill both -expand true\n\
pack $w.bar.ff.f -side top -fill x\n\
\n\
\n\
button $w.bar.quit -bitmap eject -borderwidth 1 -relief raised \\\n\
-highlightthickness 0 -font $f -command \"$self done\"\n\
\n\
pack $w.bar.rate -side right -fill y\n\
pack $w.bar.timerVal -side right -pady 0 \\\n\
-ipady 1 -padx 1 -fill y\n\
pack $w.bar.quit -side right -padx 1 -pady 1 -fill both -expand true\n\
pack $w.bar.ff -side right -padx 1 -pady 1 -fill both -expand true\n\
pack $w.bar.run -side right -padx 1 -pady 1 -fill both -expand true\n\
pack $w.bar.stop -side right -padx 1 -pady 1 -fill both -expand true\n\
pack $w.bar.back -side right -padx 1 -pady 1 -fill both -expand true\n\
pack $w.bar.rew -side right -padx 1 -pady 1 -fill both -expand true\n\
\n\
pack $w.bar -fill x -expand 1 -side right\n\
$self instvar prevbutton\n\
set prevbutton $w.bar.stop\n\
\n\
$self highlight $w.bar.stop 1\n\
}\n\
\n\
Animator instproc build-zoombar {view w mainW} {\n\
$self instvar magnification viewOffset \n\
set magnification 1.0\n\
set viewOffset(x) 0.0\n\
set viewOffset(y) 0.0\n\
frame $w.f\n\
pack $w.f -side top\n\
button $w.f.b1 -bitmap \"zoomin\" -command \"$view zoom 1.6\" \\\n\
-highlightthickness 0 -borderwidth 1\n\
pack $w.f.b1 -side top -ipady 3\n\
button $w.f.b2 -bitmap \"zoomout\" -command \"$view zoom 0.625\" \\\n\
-highlightthickness 0 -borderwidth 1\n\
pack $w.f.b2 -side top -ipady 3\n\
\n\
if {[winfo name $mainW] != \"view\"} {\n\
button $w.f.b3 -bitmap \"eject\" -command \"destroy $mainW\" \\\n\
-highlightthickness 0 -borderwidth 1\n\
pack $w.f.b3 -side top -ipady 3\n\
}\n\
}\n\
\n\
Animator instproc build-slider {w} {\n\
$self instvar timeslider timeslider_width timeslider_tag \\\n\
timeslider_pos nowDisp \n\
\n\
frame $w.f -borderwidth 2 -relief groove\n\
pack $w.f -side top -fill x -expand 1\n\
set timeslider(height) 12\n\
set timeslider(swidth) 32\n\
set timeslider(width) 32\n\
set timeslider_width($w.f.c) 32\n\
set timeslider(canvas) $w.f.c\n\
lappend timeslider(canvas_set) $timeslider(canvas)\n\
set timeslider(frame) $w\n\
canvas $w.f.c -height $timeslider(height) -width 300 \\\n\
-background white -highlightthickness 0\n\
pack $w.f.c -side left -fill x -expand 1 -padx 0 -pady 0\n\
\n\
label $w.f.c.b -bitmap time -highlightthickness 0 -borderwidth 1 \\\n\
-relief raised\n\
set timeslider_tag($w.f.c) [$w.f.c create window \\\n\
[expr $timeslider(swidth)/2] 0 -window $w.f.c.b \\\n\
-height 12 -width $timeslider(swidth) -anchor n]\n\
set timeslider_pos($w.f.c) 0\n\
bind $w.f.c <ButtonPress-1> \"$self timeslidertrough $w.f.c %x %y\"\n\
bind $w.f.c.b <ButtonPress-1> \"$self timesliderpress $w.f.c %x %y;break\"\n\
bind $w.f.c.b <ButtonRelease-1> \"$self timesliderrelease $w.f.c %x %y\"\n\
bind $w.f.c.b <B1-Motion> \"$self timeslidermotion $w.f.c %x %y\"\n\
bind $w.f.c <Configure> \"$self timeticks $w.f.c\"\n\
}\n\
\n\
Animator instproc timeticks { wfc } {\n\
$self instvar timeslider mintime range timeslider_width tlw_ \\\n\
now timeslider_tag maxtime\n\
set timeslider(canvas) $wfc\n\
\n\
set st [lindex [split $wfc \".\"] 2]\n\
if { [string compare $st \"ctrl\"] == 0 } {\n\
set width [winfo width $timeslider(canvas)]\n\
} else {\n\
if { [string compare $st \"slider\"] == 0 } {\n\
set namgraphname_ [lindex [split $wfc \".\"] 1]\n\
set width [winfo width .$namgraphname_.main.c]\n\
} else {                    \n\
set width [winfo width $tlw_.$st.main.c]\n\
}\n\
}\n\
if {$width == $timeslider_width($wfc)} { return }\n\
set timeslider(width) $width\n\
set timeslider_width($wfc) $width\n\
$timeslider(canvas) delete ticks\n\
\n\
pack forget $timeslider(canvas)\n\
update\n\
update idletasks\n\
pack $timeslider(canvas) -side left -fill x -expand 1 -padx 0 -pady 0\n\
\n\
set width [winfo width $wfc]\n\
\n\
set x [expr $timeslider(swidth)/2]\n\
set tickIncr [expr $range / ($width-$timeslider(swidth))]\n\
set intertick [expr ($width-$timeslider(swidth))/(10 * $range)]\n\
if {$intertick < 2} {\n\
set intertick 2\n\
}\n\
for {set t $mintime} {$t < ($range+$mintime)} {set t [expr $t+$intertick*$tickIncr]} {\n\
set intx [expr int($x)]\n\
$timeslider(canvas) addtag ticks withtag \\\n\
[$timeslider(canvas) create line \\\n\
$intx [expr $timeslider(height)/2] \\\n\
$intx $timeslider(height)]\n\
set x [expr $x+$intertick]\n\
}\n\
set x [expr $timeslider(swidth)/2]\n\
set intertick [expr ($width-$timeslider(swidth))/($range)]\n\
if {$intertick < 20} {\n\
set intertick 20\n\
}\n\
for {set t $mintime} {$t < ($range+$mintime)} {set t [expr $t+$intertick*$tickIncr]} {\n\
set intx [expr int($x)]\n\
$timeslider(canvas) addtag ticks withtag \\\n\
[$timeslider(canvas) create line \\\n\
$intx 0 $intx $timeslider(height)]\n\
set x [expr $x+$intertick]\n\
}\n\
\n\
set wfc_width [winfo width $wfc]\n\
set x [expr ($wfc_width-$timeslider(swidth))*$now/$maxtime]\n\
$wfc coords $timeslider_tag($wfc) [expr $x + $timeslider(swidth)/2] 0\n\
}\n\
\n\
Animator instproc timesliderset {t} {\n\
$self instvar timeslider timeslider_width timeslider_tag \\\n\
timeslider_pos maxtime tlw_\n\
\n\
foreach timeslider_canvas $timeslider(canvas_set) {\n\
if {[winfo exists $timeslider_canvas]==1} {\n\
set timeslider(width) \\\n\
$timeslider_width($timeslider_canvas)\n\
set x [expr ($timeslider(width)-$timeslider(swidth))*$t/1000.0]\n\
$timeslider_canvas coords \\\n\
$timeslider_tag($timeslider_canvas) \\\n\
[expr $x + $timeslider(swidth)/2] 0\n\
set timeslider_pos($timeslider_canvas) $x\n\
\n\
set arr [split $timeslider_canvas \".\"]\n\
set arr1 [split [lindex $arr 2] \"-\"]\n\
if {[lindex $arr1 0] == \"namgraph\"} {\n\
set arr0 [lindex $arr 2]\n\
$self draw_traceline $tlw_.$arr0.main.c $t 0 1000.0\n\
}\n\
}\n\
}\n\
}\n\
\n\
Animator instproc timesliderpress {w x y} {\n\
$self instvar timeslider sliderPressed \n\
set timeslider(oldpos) $x\n\
$w.b configure -relief sunken\n\
set sliderPressed 1\n\
}\n\
\n\
Animator instproc timeslidertrough {w x y} {\n\
$self instvar timeslider sliderPressed timeslider_pos\n\
if {$timeslider_pos($w)>$x} {\n\
$self rewind\n\
} else {\n\
$self fast_fwd\n\
}\n\
}\n\
\n\
Animator instproc timeslidermotion {wc x y} {\n\
$self instvar timeslider mintime range timeslider_tag \\\n\
timeslider_pos timeslider_width\n\
$self tkvar nowDisp\n\
\n\
set diff [expr $x - $timeslider(oldpos)]\n\
\n\
set timeslider(canvas) $wc\n\
\n\
$timeslider(canvas) move $timeslider_tag($wc) \\\n\
$diff 0\n\
\n\
set timeslider_pos($wc) [expr $timeslider_pos($wc) + $diff]\n\
if {$timeslider_pos($wc)<0} {\n\
$timeslider(canvas) move $timeslider_tag($wc) \\\n\
[expr 0 - $timeslider_pos($wc)] 0\n\
set timeslider_pos($wc) 0\n\
}\n\
if {$timeslider_pos($wc)>[expr $timeslider_width($wc)-$timeslider(swidth)]} {\n\
$timeslider(canvas) move $timeslider_tag($wc) \\\n\
[expr ($timeslider_width($wc)-$timeslider(swidth))-$timeslider_pos($wc)] 0\n\
set timeslider_pos($wc) [expr $timeslider_width($wc)-$timeslider(swidth)]\n\
}\n\
set tick 0\n\
catch {\n\
set tick [expr 1000.0*$timeslider_pos($wc)/($timeslider_width($wc)-$timeslider(swidth))]\n\
}\n\
set now [expr ($tick * $range) / 1000. + $mintime]\n\
set nowDisp [format %.6f $now]\n\
set timeslider(tick) $tick\n\
\n\
$self timesliderset [expr int(1000. * ($now - $mintime) / $range)]\n\
}\n\
\n\
Animator instproc timesliderrelease {w x y} {\n\
$self instvar timeslider sliderPressed running\n\
\n\
$self timeslidermotion $w $x $y\n\
$w.b configure -relief raised\n\
$self slidetime $timeslider(tick) 1\n\
set sliderPressed 0\n\
if $running {\n\
$self renderFrame\n\
}\n\
}\n\
\n\
Animator instproc nam-relayout {} {\n\
$self tkvar ITERATIONS KCa KCr Recalc \n\
$self instvar now netModel\n\
\n\
$netModel do_relayout $ITERATIONS $KCa $KCr $Recalc\n\
$self settime $now\n\
update idletasks\n\
}\n\
\n\
Animator instproc set-layout-params { iter kca kcr } {\n\
$self tkvar ITERATIONS KCa KCr \n\
set ITERATIONS $iter\n\
set KCa $kca \n\
set KCr $kcr\n\
}\n\
\n\
Animator instproc build-layout {w} {\n\
$self tkvar ITERATIONS KCa KCr Recalc\n\
$self instvar NETWORK_MODEL \n\
if {$NETWORK_MODEL != \"NetworkModel/Auto\"} {\n\
return\n\
}\n\
\n\
set f [smallfont]\n\
label $w.label -text \"Auto layout:\" -font $f\n\
label $w.label_ca -text \"Ca\" -font $f\n\
entry $w.inputca -width 6 -relief sunken \\\n\
-textvariable [$self tkvarname KCa] -font $f\n\
label $w.label_cr -text \"Cr\" -font $f\n\
entry $w.inputcr -width 6 -relief sunken \\\n\
-textvariable [$self tkvarname KCr] -font $f\n\
label $w.label_iter -text \"Iterations\" -font $f\n\
entry $w.inputiter -width 6 -relief sunken \\\n\
-textvariable [$self tkvarname ITERATIONS]\n\
\n\
set Recalc 1\n\
checkbutton $w.recalc -text Recalc -onvalue 1 -offvalue 0 \\\n\
-variable [$self tkvarname Recalc] -font $f \\\n\
-highlightthickness 0\n\
\n\
$self instvar netModel\n\
button $w.reset -text reset -relief raised -font $f \\\n\
-command \"$netModel reset\"\n\
\n\
button $w.relayout -text re-layout -relief raised -font $f \\\n\
-command \"$self nam-relayout\"\n\
\n\
pack $w.label -side left -padx 1 -pady 1\n\
pack $w.label_ca -side left -padx 1 -pady 1 -fill x\n\
pack $w.inputca -side left -padx 1 -pady 1 -fill x\n\
pack $w.label_cr -side left -padx 1 -pady 1 -fill x\n\
pack $w.inputcr -side left -padx 1 -pady 1 -fill x\n\
\n\
pack $w.label_iter -side left -padx 1 -pady 1 -fill x\n\
pack $w.inputiter -side left -padx 1 -pady 1 -fill x\n\
pack $w.recalc -side left -padx 1 -pady 1 -fill both\n\
pack $w.reset -side right -padx 1 -pady 1 -fill both\n\
pack $w.relayout -side right -padx 1 -pady 1 -fill both\n\
\n\
bind $w.inputca <Return> \" $self nam-relayout\"\n\
bind $w.inputcr <Return> \" $self nam-relayout\"\n\
bind $w.inputiter <Return> \"$self nam-relayout\"\n\
}\n\
\n\
Animator instproc build-annotation { w } {\n\
$self tkvar showpanel\n\
$self instvar annoBox annoBoxHeight annoJump\n\
frame $w.spaceral -borderwidth 0 -highlightthickness 0 \\\n\
-height 0 -width 10\n\
pack $w.spaceral -side top -padx 0 -pady 0\n\
frame $w.f -borderwidth 0 -highlightthickness 0\n\
frame $w.f.f\n\
\n\
set annoJump 0\n\
set annoBoxHeight 3\n\
listbox $w.f.f.a -xscrollcommand \"$w.f.f.ah set\" \\\n\
-yscrollcommand \"$w.f.f2.av set\" -height $annoBoxHeight \\\n\
-selectmode single \n\
pack $w.f.f.a -fill both -side top -expand true \n\
set annoBox $w.f.f.a\n\
\n\
scrollbar $w.f.f.ah -orient horizontal -width 10 -borderwidth 1 \\\n\
-command \"$w.f.f.a xview\"\n\
$w.f.f.ah set 0.0 1.0\n\
pack $w.f.f.ah -side bottom -fill x\n\
\n\
frame $w.f.f2\n\
pack $w.f.f2 -side left -fill y\n\
scrollbar $w.f.f2.av -orient vertical -width 10 -borderwidth 1 \\\n\
-command \"$w.f.f.a yview\"\n\
$w.f.f2.av set 0.0 1.0\n\
pack $w.f.f2.av -side top -fill y -expand true\n\
pack $w.f.f -side left -fill both -expand true\n\
trace variable showpanel(annotate) w \\\n\
\"$self displaypanel $w.f $w.spaceral annotate top both true\"\n\
\n\
bind $w.f.f.a <Double-ButtonPress-1> \"$self jump_to_annotation $w.f.f.a\"\n\
bind $w.f.f.a <ButtonPress-3> \"$self popup_annotation $w \\%x \\%y\"\n\
}\n\
\n\
Animator instproc displaypanel {panel after name side fill expand args} {\n\
$self tkvar showpanel\n\
\n\
if {$showpanel($name) == 1} {\n\
set str \"pack $panel -side $side -fill $fill -expand $expand\"\n\
if {$after!=\"\"} {\n\
set str \"$str -after $after\"\n\
}\n\
eval $str\n\
} else {\n\
pack forget $panel\n\
}\n\
}\n\
\n\
Animator instproc closepanel { name } {\n\
$self tkvar showpanel\n\
set showpanel($name) 0\n\
}\n\
\n\
Animator instproc highlight {w mode} {\n\
$self instvar prevbutton\n\
if {$mode==1} {\n\
$prevbutton.b configure -relief raised\n\
$prevbutton.f configure -background [option get . background Nam]\n\
set prevbutton $w\n\
}\n\
$w.f configure -background seagreen\n\
$w.f configure -relief sunken\n\
}\n\
\n\
Animator instproc trace_running_handler { w args } { \n\
$self instvar direction running\n\
\n\
if {$running == 0} {\n\
$self highlight $w.bar.stop 1 \n\
} elseif {($direction == 1)} {\n\
$self highlight $w.bar.run 1\n\
} else {\n\
$self highlight $w.bar.back 1\n\
}\n\
}\n\
\n\
Animator instproc window_bind {w} {\n\
bind $w <q> \"$self done\"\n\
bind $w <Q> \"$self all_done\"\n\
bind $w <Control-c> \"$self done\"\n\
\n\
bind $w <b> \"$self back_step\"\n\
bind $w <B> \"$self back_step\"\n\
\n\
bind $w <c> \"$self play 1\"\n\
bind $w <C> \"$self play 1\"\n\
bind $w <f> \"$self fast_fwd\"\n\
bind $w <F> \"$self fast_fwd\"\n\
bind $w <n> \"$self next_event\"\n\
bind $w <N> \"$self next_event\"\n\
bind $w <p> \"$self stop 1\"\n\
bind $w <P> \"$self stop 1\"\n\
bind $w <r> \"$self rewind\"\n\
bind $w <R> \"$self rewind\"\n\
bind $w <u> \"$self time_undo\"\n\
bind $w <U> \"$self time_undo\"\n\
bind $w <x> \"$self rate_undo\"\n\
bind $w <X> \"$self rate_undo\"\n\
bind $w <period> \"$self change_rate 1\"\n\
bind $w <greater> \"$self change_rate 1\"\n\
bind $w <comma> \"$self change_rate 0\"\n\
bind $w <less> \"$self change_rate 0\"\n\
}\n\
\n\
Animator instproc view_bind {netView} {\n\
bind $netView <space> \"$self toggle_pause\"\n\
bind $netView <Control-d> \"$self done\"\n\
bind $netView <Return> \"$self single_step\"\n\
bind $netView <BackSpace> \"$self back_step\"\n\
bind $netView <Delete> \"$self back_step\"\n\
bind $netView <0> \"$self reset\"\n\
\n\
bind $netView <ButtonPress-1> \"$self start_info $netView \\%x \\%y left\"\n\
bind $netView <ButtonPress-3> \"$self start_info $netView \\%x \\%y right\"\n\
bind $netView <ButtonPress-2> \"$self view_drag_start $netView \\%x \\%y\"\n\
bind $netView <B2-Motion> \"$self view_drag_motion $netView \\%x \\%y\"\n\
}\n\
\n\
\n\
Animator instproc tracehooktcl { e } {\n\
\n\
$self notifyObservers $e\n\
}\n\
\n\
Animator instproc update_statsview { s event } {\n\
\n\
$self instvar colorset highest_seq timeslider maxtime colorname subView \\\n\
subViewRange plotdatax plotdatay plotmark\n\
\n\
set s_len [string length $s]\n\
set session_id [string index $s [expr $s_len-1]]\n\
\n\
set sid [get_trace_item \"-S\" $event]\n\
\n\
if {$sid != $session_id} {return}\n\
\n\
set extinfo [get_trace_item \"-x\" $event]\n\
set time [get_trace_item \"-t\" $event]\n\
set seqno [lindex $extinfo 2]\n\
set colorid [get_trace_item \"-a\" $event]\n\
set mid [get_trace_item \"-m\" $event]\n\
\n\
if { $mid == \"\" } {return}\n\
\n\
set cnt 0\n\
while {[info exists plotdatax($sid.$cnt)]} {\n\
$self plot_xy $s.main.c $time $seqno 0 $maxtime 0 $highest_seq($sid) \\\n\
$colorid $plotmark($sid.$mid) 0\n\
incr cnt\n\
}\n\
\n\
foreach subviews $subView(#$session_id) {\n\
if {![winfo exists $subviews]} {continue}\n\
\n\
set minx [lindex $subViewRange($subviews) 0]\n\
set maxx [lindex $subViewRange($subviews) 1]\n\
set miny [lindex $subViewRange($subviews) 2]\n\
set maxy [lindex $subViewRange($subviews) 3]\n\
$self plot_xy $subviews.main.c $time $seqno $minx $maxx \\\n\
$miny $maxy $colorid $plotmark($sid.$mid) 1\n\
\n\
}\n\
}\n\
\n\
\n\
Animator instproc new_waitingtext { msg } {\n\
$self instvar windows \n\
$windows(title) configure -text \"Please wait - $msg\"\n\
update\n\
}\n\
\n\
Animator instproc restore_waitingtext {} {\n\
$self instvar windows nam_name\n\
$windows(title) configure -text $nam_name\n\
}\n\
\n\
Animator instproc active_sessions {} {\n\
$self instvar analysis_ready colorset colorindex session_id colorname \\\n\
netModel analysis_flag windows nam_name tlw_ cache_ready\n\
\n\
if {[string compare $analysis_flag \"0\"] == 0} {\n\
set analysis_flag 1\n\
}\n\
\n\
set w $tlw_.activesessions\n\
\n\
if {[winfo exists $w]} {\n\
puts \"There exists current active session window!\"\n\
return\n\
} \n\
$windows(title) configure -text \"Please wait ... \"\n\
update\n\
if { $analysis_ready == 1 && $cache_ready == 0 } {\n\
$self cache_plot\n\
set cache_ready 1\n\
}\n\
$windows(title) configure -text $nam_name\n\
\n\
\n\
toplevel $w\n\
\n\
wm title $w \"Current Active Sessions\"\n\
\n\
frame $w.f \n\
pack $w.f -side top\n\
\n\
label $w.f.label_left -text \"LEGEND\"\n\
label $w.f.label_right -text \"SESSIONS\"\n\
\n\
for {set i 0} { $i < $colorindex } { incr i} {\n\
\n\
label $w.f.label_left$i -text \"    \" -bg $colorname($i);\n\
set stats_title $session_id($i)\n\
button $w.f.button$i -text $session_id($i) \\\n\
-command \"$self make_mainwin \\\"$i\\\"\"\n\
\n\
}\n\
\n\
grid config $w.f.label_left -column 0 -row 0 -sticky \"n\"\n\
grid config $w.f.label_right -column 1 -row 0 -sticky \"n\"\n\
\n\
for {set i 0} { $i < $colorindex } { incr i} {\n\
grid config $w.f.label_left$i -column 0 -row [expr $i+1] \\\n\
-sticky \"snew\"\n\
grid config $w.f.button$i -column 1 -row [expr $i+1] \\\n\
-sticky \"snew\"\n\
}\n\
}\n\
\n\
Animator instproc auto_legend {} {\n\
\n\
$self instvar Mcnt plotmarks colorname filter_id filtercolor_id colorindex tlw_ \n\
\n\
set w $tlw_.autolegend\n\
\n\
if {[winfo exists $w]} {\n\
puts \"There exists current auto legend  window!\"\n\
return\n\
}\n\
\n\
toplevel $w\n\
wm title $w \"Current Filter Legend\"\n\
\n\
frame $w.f\n\
pack $w.f -side top\n\
\n\
label $w.f.label_left -text \"LEGEND\"\n\
label $w.f.label_right -text \"EXPLANATION\"\n\
\n\
for {set i 0} { $i < $Mcnt } { incr i} {\n\
\n\
\n\
\n\
label $w.f.label_left$i -bitmap $plotmarks($i) -fg $colorname($filtercolor_id($i))\n\
\n\
label $w.f.button$i -text $filter_id($i)\n\
\n\
}\n\
\n\
grid config $w.f.label_left -column 0 -row 0 -sticky \"n\"\n\
grid config $w.f.label_right -column 1 -row 0 -sticky \"n\"\n\
\n\
for {set i 0} { $i < $Mcnt } { incr i} {\n\
\n\
grid config $w.f.label_left$i -column 0 -row [expr $i+1] \\\n\
-sticky \"snew\"\n\
grid config $w.f.button$i -column 1 -row [expr $i+1] \\\n\
-sticky \"snew\"\n\
}\n\
\n\
}\n\
\n\
Animator instproc ScrolledCanvas { c width height region } {\n\
frame $c\n\
canvas $c.canvas -width $width -height $height \\\n\
-scrollregion $region \\\n\
-xscrollcommand [list $c.xscroll set] \\\n\
-yscrollcommand [list $c.yscroll set]\n\
scrollbar $c.xscroll -orient horizontal \\\n\
-command [list $c.canvas xview]\n\
scrollbar $c.yscroll -orient vertical \\\n\
-command [list $c.canvas yview]\n\
pack $c.xscroll -side bottom -fill x\n\
pack $c.yscroll -side right -fill y\n\
pack $c.canvas -side left -fill both -expand true\n\
pack $c -side top -fill both -expand true\n\
return $c.canvas\n\
}\n\
\n\
Animator instproc build.m0 { w } {\n\
bind $w <Configure> \"$self xtimeticks $w\"\n\
}\n\
\n\
Animator instproc xtimeticks { w } {\n\
$self instvar timeslider mintime range timeslider_width\n\
\n\
set width [winfo width $w]\n\
set height [winfo height $w]\n\
\n\
$w delete ticks\n\
\n\
set x [expr $timeslider(swidth)/2]\n\
set intertick [expr ($width-$timeslider(swidth))/(10 * $range)]\n\
for {set t $mintime} {$t < ($range+$mintime)} {set t [expr $t+0.1]} {\n\
set intx [expr int($x)]\n\
$w addtag ticks withtag \\\n\
[$w create line \\\n\
$intx [expr $timeslider(height)/2 + $height*9/10] $intx [expr $timeslider(height) + $height*9/10]]\n\
set x [expr $x+$intertick]\n\
}\n\
\n\
set orx [expr $timeslider(swidth)/2]\n\
$w addtag ticks withtag \\\n\
[$w create line $orx [expr $timeslider(height)+$height*9/10] $x [expr $timeslider(height)+$height*9/10]]\n\
$w addtag ticks withtag \\\n\
[$w create line $orx [expr $timeslider(height)+$height*9/10] $orx 0]]\n\
\n\
set x [expr $timeslider(swidth)/2]\n\
set intertick [expr ($width-$timeslider(swidth))/($range)]\n\
for {set t $mintime} {$t < ($range+$mintime)} {set t [expr $t+1]} {\n\
set intx [expr int($x)]\n\
$w addtag ticks withtag \\\n\
[$w create line \\\n\
$intx [expr $timeslider(height) + $height*9/10] $intx [expr $height*9/10]]\n\
set x [expr $x+$intertick]\n\
}\n\
}\n\
\n\
\n\
Animator instproc make_mainwin { sid } {\n\
$self tkvar model_ \n\
$self instvar session_id\n\
$model_($sid) startview $session_id($sid)\n\
}\n\
\n\
\n\
\n\
Animator instproc nam_analysis { tracefile } {\n\
$self instvar analysis_OK analysis_ready trace cache_ready\n\
\n\
set file [open $tracefile \"r\"]\n\
set line [gets $file]\n\
set time [get_trace_item \"-t\" $line]\n\
\n\
\n\
while {([eof $file]==0)&&([string compare $time \"*\"]!=0)} {\n\
set line [gets $file]\n\
set time [get_trace_item \"-t\" $line] \n\
}\n\
\n\
while {([eof $file]==0)&&([string compare $time \"*\"]==0) } {\n\
set cmd [lindex $line 0]\n\
if [regexp {^\\#} $cmd] {\n\
continue\n\
}\n\
\n\
switch \"$cmd\" {\n\
\"V\" {\n\
$self handle_version $line\n\
}\n\
\"N\" {\n\
$self handle_analysis $line\n\
}\n\
\"c\" {\n\
$self handle_colorname $line\n\
}\n\
}\n\
set line [gets $file]\n\
set time [get_trace_item \"-t\" $line]\n\
}\n\
close $file\n\
\n\
if { $analysis_OK == 0 } { \n\
puts \"You are using the tracefile format older than 1.0a5\"\n\
puts \"which will not allow you to run namgraph\"\n\
return\n\
}\n\
\n\
set cache_ready 0\n\
}\n\
\n\
Animator instproc cache_plot { } {\n\
$self instvar tracefile plotdatax plotdatay plotmark plotmarks plotcolor\n\
\n\
if ![info exists plotmarks] {\n\
set plotmarks(0) mark1\n\
set plotmarks(1) mark2\n\
set plotmarks(2) mark3\n\
set plotmarks(3) mark4\n\
set plotmarks(4) mark5\n\
set plotmarks(5) mark6\n\
set plotmarks(6) mark7\n\
set plotmarks(7) mark8\n\
set plotmarks(8) mark1\n\
set plotmarks(9) mark2\n\
set plotmarks(10) mark3\n\
set plotmarks(11) mark4\n\
set plotmarks(12) mark5\n\
set plotmarks(13) mark6\n\
set plotmarks(14) mark7\n\
set plotmarks(15) mark8\n\
\n\
}\n\
\n\
set file [open $tracefile \"r\"]\n\
$self tkvar model_\n\
\n\
while {[eof $file]==0} {\n\
set line [gets $file]\n\
set time [get_trace_item \"-t\" $line]\n\
\n\
if {[string compare $time \"*\"]==0 } {continue}\n\
\n\
set Sid [get_trace_item \"-S\" $line]\n\
set mid [get_trace_item \"-m\" $line]\n\
set pid [get_trace_item \"-p\" $line]\n\
set fid [get_trace_item \"-f\" $line]\n\
set yvalset [get_trace_item \"-y\" $line]\n\
\n\
set yval [lindex $yvalset 0]\n\
set ymark [lindex $yvalset 1]\n\
\n\
if { $mid == \"\" } {continue}\n\
\n\
set plotmark($Sid.$mid) $plotmarks($mid)\n\
set plotcolor($Sid.$mid) $fid\n\
\n\
\n\
if ![info exists model_($Sid)] {\n\
set model_($Sid) [new NamgraphModel $Sid $self]\n\
$self addObserver $model_($Sid)\n\
}\n\
\n\
set current_model $model_($Sid)\n\
$current_model adddata $self $mid $time $yval $ymark\n\
\n\
}\n\
close $file\n\
}\n\
\n\
Animator instproc handle_analysis { line } {\n\
\n\
$self instvar session_id filter_id colorname highest_seq filtercolor_id \\\n\
ymark\n\
\n\
set index [get_trace_item \"-S\" $line]\n\
set findex [get_trace_item \"-F\" $line]\n\
set title [get_trace_item \"-n\" $line]\n\
set hseq [get_trace_item \"-h\" $line]\n\
set mindex [get_trace_item \"-M\" $line]\n\
set groupm [get_trace_item \"-m\" $line]\n\
set proto [get_trace_item \"-p\" $line]\n\
\n\
if { $index != \"\" && $title != \"\" } {\n\
set session_id($index) $title\n\
set proto_id($index) $proto\n\
}\n\
if { $index != \"\" && $hseq != \"\" } {\n\
set highest_seq($index) $hseq\n\
}\n\
if { $findex != \"\" } {\n\
set filter_id($mindex) $title\n\
set filtercolor_id($mindex) $findex\n\
}\n\
\n\
}\n\
\n\
Animator instproc handle_colorname { line } {\n\
$self instvar colorname\n\
set index [get_trace_item \"-i\" $line] \n\
set colorn [get_trace_item \"-n\" $line]\n\
set colorname($index) $colorn\n\
}\n\
\n\
Animator instproc handle_version { line } {\n\
\n\
$self instvar analysis_OK nam_version analysis_ready colorindex \\\n\
highest_seq Mcnt\n\
\n\
set nam_version [get_trace_item \"-v\" $line]\n\
if { $nam_version >= \"1.0a5\" } {\n\
set analysis_OK 1\n\
}\n\
set analysis_ready [get_trace_item \"-a\" $line]\n\
set colorindex [get_trace_item \"-c\" $line]\n\
set Mcnt [get_trace_item \"-M\" $line]\n\
}\n\
\n\
Animator instproc viewgraph { object graphtype tracefile } {\n\
$self instvar netView now timeslider windows nam_name graphs tlw_ \n\
\n\
if {$object==\"\"} {return}\n\
set graphtrace [new Trace $tracefile $self]\n\
set netgraph \"\"\n\
switch [lindex $object 0] {\n\
l {\n\
set netgraph [new LinkNetworkGraph]\n\
switch $graphtype {\n\
\"bw\" {\n\
$netgraph bw [lindex $object 1] [lindex $object 2]\n\
}\n\
\"loss\" {\n\
$netgraph loss [lindex $object 1] [lindex $object 2]\n\
}\n\
}\n\
}\n\
f {\n\
set netgraph [new FeatureNetworkGraph]\n\
$netgraph feature [lindex $object 1] [lindex $object 2] [lindex $object 3]\n\
}\n\
}\n\
\n\
if {$netgraph==\"\"} {\n\
return\n\
}\n\
set name [lindex $object 0]_[lindex $object 1]_[lindex $object 2]_$graphtype\n\
\n\
if {[winfo exists $tlw_.graph.f$name]==1} {\n\
return\n\
}\n\
\n\
$windows(title) configure -text \"Please wait - reading tracefile...\"\n\
update\n\
set maxtime [$graphtrace maxtime]\n\
set mintime [$graphtrace mintime]\n\
$graphtrace connect $netgraph\n\
$netgraph timerange $mintime $maxtime\n\
\n\
$graphtrace settime $maxtime 1\n\
\n\
set w $tlw_.graph\n\
if {[winfo exists $w]==0} {\n\
frame $w \n\
pack $w -side top -fill x -expand true -after $timeslider(frame)\n\
}\n\
lappend graphs $netgraph\n\
frame $w.f$name -borderwidth 2 -relief groove\n\
pack $w.f$name -side top -expand true -fill both\n\
label $w.f$name.pr -bitmap pullright -borderwidth 1 -relief raised\n\
bind $w.f$name.pr <Enter> \\\n\
\"$self viewgraph_label \\\"[$self viewgraph_name $object $graphtype]\\\" \\\n\
$w.f$name $w.f$name.pr $netgraph\"\n\
pack $w.f$name.pr -side left\n\
$netgraph view $w.f$name.view\n\
\n\
$netgraph settime $now\n\
\n\
pack $w.f$name.view -side left -expand true \\\n\
-fill both\n\
frame $w.f$name.l2 -width [expr $timeslider(swidth)/2] -height 30\n\
pack $w.f$name.l2 -side left\n\
$windows(title) configure -text $nam_name\n\
}\n\
\n\
Animator instproc viewgraph_label {info win where netgraph} {\n\
$self instvar tlw_\n\
\n\
if {[winfo exists $win.lbl]==0} {\n\
frame $win.lbl -borderwidth 2 -relief groove\n\
button $win.lbl.hide -text \"Hide\" -relief raised -borderwidth 1 \\\n\
-highlightthickness 0 \\\n\
-command \"destroy $win;\\\n\
$self rm_list_entry graphs $netgraph;\\\n\
if {\\[winfo children $tlw_.graph\\]=={}} {destroy $tlw_.graph}\"\n\
pack $win.lbl.hide -side left\n\
label $win.lbl.l -text $info -font [smallfont]\n\
pack $win.lbl.l -side left\n\
}\n\
catch {\n\
pack $win.lbl -side left -after $where -fill y\n\
pack forget $where\n\
bind $win.lbl <Leave> \\\n\
\"pack $where -side left -before $win.lbl;pack forget $win.lbl\"\n\
}\n\
}\n\
\n\
Animator instproc rm_list_entry {var value} {\n\
$self instvar $var\n\
set res \"\"\n\
set lst [set [set var]]\n\
foreach el $lst {\n\
if {[string compare $el $value]!=0} {\n\
lappend res $el\n\
}\n\
}\n\
set [set var] $res\n\
}\n\
\n\
Animator instproc viewgraph_name {name graphtype} {\n\
set type [lindex $name 0]\n\
switch $type {\n\
\"l\" {\n\
switch $graphtype {\n\
\"bw\" {\n\
return \"Bandwidth used on link [lindex $name 1]->[lindex $name 2]\"\n\
}\n\
\"loss\" {\n\
return \"Packets dropped on link [lindex $name 1]->[lindex $name 2]\"\n\
}\n\
}\n\
}\n\
\"f\" {\n\
return \"[lindex $name 2] [lindex $name 3]\"\n\
\n\
}\n\
}\n\
return unknown\n\
}\n\
\n\
\n\
Class Observer\n\
Observer set uniqueID_ 0\n\
\n\
Observer proc getid {} {\n\
set id [Observer set uniqueID_]\n\
Observer set uniqueID_ [expr $id + 1]\n\
return $id\n\
}\n\
\n\
Observer instproc init {} {\n\
\n\
$self instvar id_\n\
set id_ [Observer getid]\n\
}\n\
\n\
Observer instproc id {} {\n\
$self instvar id_\n\
return $id_\n\
}\n\
\n\
\n\
Observer instproc update {} {\n\
\n\
}\n\
\n\
Class Observable\n\
\n\
Observable instproc init {} {\n\
$self instvar observerlist_ \n\
set observerlist_ \"\"\n\
}\n\
\n\
\n\
Observable instproc addObserver { o } {\n\
$self instvar observerlist_\n\
\n\
set cnt 0\n\
set oid [$o id]\n\
foreach ob $observerlist_ {\n\
set obid [$ob id]\n\
if { $oid == $obid } {\n\
set cnt 1\n\
break;\n\
}\n\
}  \n\
\n\
if { $cnt == 0 } {\n\
lappend observerlist_ $o\n\
}\n\
\n\
}\n\
\n\
\n\
Observable instproc  deleteObserver { o } {\n\
\n\
$self instvar observerlist_\n\
set backlist_ \"\"\n\
set oid [$o id]\n\
foreach ob $observerlist_ {\n\
set obid [$ob id]\n\
if { $oid != $obid } {\n\
lappend backlist_ $ob\n\
} else {\n\
}\n\
}\n\
\n\
set observerlist_ $backlist_\n\
}\n\
\n\
\n\
Observable instproc notifyObservers { arg } {\n\
\n\
$self instvar observerlist_\n\
\n\
\n\
foreach ob $observerlist_ {\n\
\n\
if ![ catch { $ob info class } ] {\n\
\n\
$ob update $arg\n\
}   \n\
\n\
}\n\
}\n\
\n\
\n\
Observable instproc countObservers {} {\n\
$self instvar observerlist_\n\
set size [llength $observerlist_]\n\
return $size\n\
}\n\
\n\
NetworkModel/Wireless set Wpxmax_ 4\n\
NetworkModel/Wireless set Wpymax_ 4\n\
\n\
NetworkModel/Wireless instproc init { animator tracefile } {\n\
eval $self next $animator $tracefile\n\
NetworkModel/Wireless instvar Wpxmax_ Wpymax_\n\
$self set_range $Wpxmax_ $Wpymax_\n\
}\n\
\n\
NetworkModel/Wireless instproc set_range { width height } {\n\
$self instvar Wpxmax_ Wpymax_\n\
set Wpxmax_ $width\n\
set Wpymax_ $height\n\
}\n\
\n\
NetworkModel/Wireless instproc add_link { e } {\n\
\n\
set val [lrange $e 1 end]\n\
\n\
$self layout_link $val\n\
\n\
}\n\
\n\
\n\
Class NamgraphView -superclass Observer\n\
\n\
NamgraphView set WinWidth  600\n\
NamgraphView set WinHeight 400\n\
\n\
NamgraphView instproc init { title ob minx maxx miny maxy tag } {\n\
\n\
$self next\n\
\n\
$self instvar id_ title_ modelobj_ winname_ minx_ maxx_ miny_ maxy_\n\
$self instvar slidetag_ timeslider\n\
\n\
set title_ $title\n\
set modelobj_ $ob\n\
set slidetag_ $tag\n\
\n\
set winname_ .namgraph-$id_\n\
\n\
set minx_ $minx\n\
set miny_ $miny\n\
set maxx_ $maxx\n\
set maxy_ $maxy\n\
\n\
set timeslider(swidth) [$ob set timeslider_swidth_]\n\
\n\
$self formwindow\n\
\n\
}\n\
\n\
\n\
NamgraphView instproc formwindow {} {\n\
\n\
$self instvar title_ winname_ minx_ maxx_ miny_ maxy_ id_ modelobj_\n\
$self instvar slidetag_\n\
\n\
toplevel $winname_\n\
\n\
set s $winname_\n\
wm title $s \"$title_-$id_\"\n\
\n\
set welcome [Animator set welcome]\n\
\n\
set width_ [NamgraphView set WinWidth]\n\
set height_ [NamgraphView set WinHeight]\n\
frame $s.menubar -bd 2 -width $width_ -relief raised -background #535380\n\
\n\
menubutton $s.menubar.file -underline 0 -text \"File\" \\\n\
-menu $s.menubar.file.menu -background #535380 -foreground #aaeca6\n\
menu $s.menubar.file.menu\n\
$s.menubar.file.menu add command -label \"Save As ...\" \\\n\
-underline 0 -command \"puts OJ\" \\\n\
-background #535380 -foreground #aaeca6 -state disabled\n\
\n\
\n\
$s.menubar.file.menu add command -label \"Close\" \\\n\
-underline 1 -command \"destroy $winname_\" \\\n\
-background #535380 -foreground #aaeca6\n\
\n\
menubutton $s.menubar.edit -underline 0 -text \"Edit\" \\\n\
-menu $s.menubar.edit.menu -background #535380 -foreground #aaeca6 \\\n\
-state disabled\n\
menu $s.menubar.edit.menu\n\
$s.menubar.edit.menu add command -label \"Preferences\" \\\n\
-underline 0 -command \"puts OJ\" \\\n\
-background #535380 -foreground #aaeca6 -state disabled\n\
\n\
\n\
menubutton $s.menubar.view -underline 0 -text \"View\" \\\n\
-menu $s.menubar.view.menu -background #535380 -foreground #aaeca6\n\
menu $s.menubar.view.menu\n\
\n\
foreach menuindex_ [$modelobj_ array names dataname] {\n\
set menuname_ [$modelobj_ set dataname($menuindex_)]\n\
$self tkvar $menuindex_\n\
set $menuindex_ 1\n\
$s.menubar.view.menu add checkbutton -label $menuname_ \\\n\
-variable [$self tkvarname $menuindex_] \\\n\
-command \"$self RefreshWin $menuindex_\" \\\n\
-background #535380 -foreground #aaeca6\n\
}\n\
\n\
menubutton $s.menubar.help -underline 0 -text \"Help\" \\\n\
-menu $s.menubar.help.menu -background #535380 -foreground #aaeca6\n\
menu $s.menubar.help.menu\n\
\n\
pack $s.menubar.file -side left\n\
pack $s.menubar.edit -side left\n\
pack $s.menubar.view -side left\n\
pack $s.menubar.help -side right\n\
\n\
\n\
frame $s.main -bd 2 -background #6b7787\n\
canvas $s.main.c -width $width_ -height $height_ -background #ffffff\n\
\n\
\n\
$s.main.c bind clickable <Button-1> \"$self startclick \\%W \\%x \\%y\"\n\
$s.main.c bind clickable <Enter> \"$self showclick \\%W \\%x \\%y\"\n\
$s.main.c bind clickable <Leave> \"$self endshow \\%W \\%x \\%y\"\n\
$s.main.c bind clickable <ButtonRelease-1> \"$self endclick \\%W \\%x \\%y\"\n\
\n\
bind $s.main.c <Button-1> \"$self startrect \\%W \\%x \\%y\"\n\
bind $s.main.c <B1-Motion> \"$self dragrect \\%W \\%x \\%y\"\n\
bind $s.main.c <ButtonRelease-1> \"$self endrect \\%W \\%x \\%y\"\n\
\n\
canvas $s.main.c.cl -width 16 -height 400 -background #6b7787\n\
canvas $s.main.c.cr -width 16 -height 400 -background #6b7787\n\
pack $s.main.c.cl -side left -fill y\n\
pack $s.main.c.cr -side right -fill y\n\
pack $s.main.c -side left -fill both -expand yes\n\
$self build.c0 $s.main.c\n\
\n\
if { $slidetag_ == 1 } {\n\
set an_id [$modelobj_ set animator_id_]\n\
frame $s.slider -bd 1 -relief flat\n\
frame $s.slider.timer -bd 1 -relief flat\n\
$an_id build-slider $s.slider.timer\n\
pack  $s.slider.timer -side left -expand true -fill x\n\
}\n\
\n\
\n\
frame $s.status -relief flat -borderwidth 1  -background #6b7787\n\
label $s.status.rem -text $welcome -textvariable \\\n\
remark -relief sunken\n\
pack $s.status.rem -side left -fill both -expand yes\n\
\n\
\n\
grid config $s.menubar -column 0 -row 0 \\\n\
-columnspan 1 -rowspan 1 -sticky \"snew\"\n\
grid config $s.main    -column 0 -row 1 \\\n\
-columnspan 1 -rowspan 1 -sticky \"snew\"\n\
\n\
if { $slidetag_ == 1 } {\n\
grid config $s.slider  -column 0 -row 2 \\\n\
-columnspan 1 -rowspan 1 -sticky \"snew\"\n\
\n\
grid config $s.status  -column 0 -row 3 \\\n\
-columnspan 1 -rowspan 1 -sticky \"snew\"\n\
\n\
\n\
} else {\n\
grid config $s.status  -column 0 -row 2 \\\n\
-columnspan 1 -rowspan 1 -sticky \"snew\"\n\
}\n\
\n\
\n\
\n\
grid columnconfigure $s 0 -weight 1\n\
grid rowconfigure $s 1 -weight 1\n\
\n\
}\n\
\n\
NamgraphView instproc RefreshWin { indexname } {\n\
\n\
\n\
$self instvar current_win_\n\
\n\
$self view_callback $current_win_\n\
\n\
\n\
}\n\
\n\
NamgraphView instproc build.c0 { w } {\n\
$self instvar current_win_ $w\n\
set current_win_ $w\n\
\n\
bind $w <Configure> \"$self view_callback $w\"\n\
}   \n\
\n\
\n\
NamgraphView instproc view_callback { w } {\n\
\n\
$self instvar modelobj_ slidetag_ \n\
$self instvar minx_ maxx_ miny_ maxy_\n\
\n\
$w delete all\n\
\n\
foreach menuindex_ [$modelobj_ array names dataname] {\n\
$self tkvar $menuindex_\n\
set menuvalue [set $menuindex_]\n\
if { $menuvalue == 1 } {\n\
set plotx [$modelobj_ set dataplotx($menuindex_)]\n\
set ploty [$modelobj_ set dataploty($menuindex_)]\n\
set plotcolor [$modelobj_ set plotcolor($menuindex_)]\n\
set plotmark [$modelobj_ set plotmark($menuindex_)]\n\
\n\
set cnt 0\n\
foreach xvalue $plotx {\n\
if { $xvalue > $minx_ && $xvalue < $maxx_ } {\n\
$self plot_xy $w $xvalue \\\n\
[lindex $ploty $cnt] $minx_ $maxx_ \\\n\
$miny_ $maxy_ $plotcolor \\\n\
$plotmark &slidetag_\n\
}\n\
incr cnt\n\
}\n\
}\n\
}\n\
\n\
$self draw_scale_xy 0\n\
}\n\
\n\
NamgraphView instproc plot_xy { c x y minx maxx miny maxy colorname markname traceflag} {\n\
$self instvar timeslider\n\
\n\
\n\
set scrxr [winfo width $c]\n\
set scryb [winfo height $c] \n\
\n\
set scrxr [expr $scrxr-$timeslider(swidth)]\n\
\n\
set yloc [expr $scryb-(($y-$miny)*$scryb/($maxy-$miny))]\n\
set xloc [expr $timeslider(swidth)/2 + (($x-$minx)*$scrxr/($maxx-$minx))]\n\
\n\
$c create bitmap $xloc $yloc -bitmap \"$markname\" -tag clickable \\\n\
-foreground $colorname\n\
\n\
}\n\
\n\
NamgraphView instproc draw_traceline { t } {\n\
$self instvar timeslider minx_ maxx_ current_win_ \n\
$self tkvar traceline\n\
\n\
set c $current_win_\n\
\n\
if { ($t < $minx_ ) || ($t > $maxx_) } {\n\
$c delete traceline\n\
return\n\
}\n\
\n\
set scrxl [expr $timeslider(swidth)/2]\n\
set scryt 0\n\
\n\
set scrxr [winfo width $c]\n\
set scryb [winfo height $c]\n\
set scrxr [expr $scrxr-$timeslider(swidth)]\n\
\n\
\n\
set traceline_x [expr $scrxl + ($t-$minx_)*$scrxr/($maxx_-$minx_)]\n\
$c delete traceline\n\
$c addtag traceline withtag \\\n\
[$c create line $traceline_x 0 $traceline_x $scryb -fill red]\n\
\n\
}\n\
\n\
NamgraphView instproc startclick {w x y} {\n\
$self instvar draglocation\n\
\n\
catch {unset draglocation}\n\
set draglocation(obj) [$w find closest $x $y]\n\
\n\
set draglocation(origx) $x\n\
set draglocation(origy) $y\n\
}   \n\
\n\
\n\
NamgraphView instproc endclick { w x y } {\n\
\n\
$self instvar draglocation timeslider maxx_ minx_ modelobj_\n\
\n\
if { $x == $draglocation(origx) && $y == $draglocation(origy)} {\n\
\n\
\n\
set width [winfo width $w]\n\
\n\
set width [expr $width-$timeslider(swidth)]\n\
set x [expr $x-$timeslider(swidth)/2]\n\
set t [expr $minx_+($maxx_-$minx_)*$x/$width]\n\
\n\
\n\
set animator [$modelobj_ animator]\n\
\n\
$animator settime $t\n\
}\n\
\n\
}\n\
\n\
NamgraphView instproc showclick { w x y } {\n\
\n\
set z [$self viewloc_proc $w $x $y]\n\
set show_msg \"Packet # [lindex $z 1] at time [lindex $z 0]\"\n\
\n\
catch {destroy $w.f}\n\
frame $w.f -relief groove -borderwidth 2\n\
message $w.f.msg -width 8c -text $show_msg\n\
pack $w.f.msg\n\
pack $w.f\n\
catch {place_frame $w $w.f [expr $x+10] [expr $y+10]}\n\
}\n\
\n\
NamgraphView instproc endshow { w x y } {\n\
catch {destroy $w.f}\n\
}\n\
\n\
\n\
NamgraphView instproc viewloc_proc  { w x y } {\n\
\n\
$self instvar timeslider \\\n\
minx_ maxx_ miny_ maxy_\n\
\n\
set width [winfo width $w]\n\
set height [winfo height $w]\n\
\n\
set width [expr $width-$timeslider(swidth)]\n\
set x [expr $x-$timeslider(swidth)/2]\n\
\n\
set x [expr $minx_+($maxx_-$minx_)*$x/$width]\n\
set y  [expr $miny_+1.0*($maxy_-$miny_)*($height-$y)/$height]\n\
\n\
set z [format \"%7.5f %10.0f\" $x $y ]\n\
return $z\n\
}\n\
\n\
\n\
NamgraphView instproc startrect {w x y} { \n\
$self instvar rectlocation\n\
\n\
catch {unset rectlocation} \n\
\n\
set rectlocation(xorig) $x\n\
set rectlocation(yorig) $y\n\
set tx [expr $x + 1] \n\
set ty [expr $y + 1]\n\
set rectlocation(obj) \\\n\
[$w create rect $x $y $tx $ty -outline gainsboro]\n\
}\n\
\n\
NamgraphView instproc dragrect {w x y} {\n\
$self instvar rectlocation\n\
$w delete $rectlocation(obj)\n\
set rectlocation(obj) \\\n\
[$w create rect $rectlocation(xorig) $rectlocation(yorig) \\\n\
$x $y -outline gainsboro]\n\
}   \n\
\n\
NamgraphView instproc endrect {w x y} {\n\
$self instvar timeslider title_ modelobj_ rectlocation\n\
$self instvar minx_ maxx_ miny_ maxy_\n\
\n\
$w delete $rectlocation(obj)\n\
\n\
if { $x == $rectlocation(xorig) || $y == $rectlocation(yorig)} {return}\n\
\n\
\n\
set width [winfo width $w]\n\
set height [winfo height $w]\n\
\n\
set width [expr $width-$timeslider(swidth)]\n\
set x [expr $x-$timeslider(swidth)/2]\n\
set rectlocation(xorig) [expr $rectlocation(xorig)-$timeslider(swidth)/2]\n\
\n\
\n\
set timestart [expr $minx_+($maxx_-$minx_)*$rectlocation(xorig)/$width]\n\
set timeend   [expr $minx_+($maxx_-$minx_)*$x/$width]\n\
set seqstart  [expr $miny_+1.0*($maxy_-$miny_)* \\\n\
($height-$rectlocation(yorig))/$height]\n\
set seqend    [expr $miny_+1.0*($maxy_-$miny_)*($height-$y)/$height]\n\
\n\
if { $timestart > $timeend } {\n\
set tmpt $timestart\n\
set timestart $timeend\n\
set timeend $tmpt\n\
}\n\
\n\
if { $seqstart > $seqend } {\n\
set tmpt $seqstart\n\
set seqstart $seqend\n\
set seqend $tmpt\n\
}\n\
\n\
set zoomview [new NamgraphView $title_ $modelobj_ $timestart \\\n\
$timeend $seqstart $seqend \"ZOOM\"]\n\
$modelobj_ addObserver $zoomview\n\
\n\
}\n\
\n\
NamgraphView instproc startmove {w o x y} {\n\
$self instvar rectlocation\n\
scan [$w coords $o] \"%f %f %f %f\" x1 y1 x2 y2\n\
set rectlocation(x) [expr abs($x - $x1)]\n\
set rectlocation(y) [expr abs($y - $y1)]\n\
}\n\
\n\
NamgraphView instproc moverect {w o x y} {\n\
$self instvar rectlocation\n\
scan [$w coords $o] \"%f %f %f %f\" x1 y1 x2 y2\n\
set dx [expr $x - $x1 - $rectlocation(x)]\n\
set dy [expr $y - $y1 - $rectlocation(y)]\n\
$w move $o $dx $dy\n\
}\n\
\n\
NamgraphView instproc draw_scale_xy { mode } {\n\
\n\
$self instvar timeslider minx_ maxx_ miny_ maxy_ current_win_\n\
$self instvar modelobj_\n\
\n\
set c $current_win_\n\
\n\
set scrxl [expr $timeslider(swidth)/2]\n\
set scryt 0\n\
\n\
set scrxr [winfo width $c]\n\
set scryb [winfo height $c]\n\
\n\
set scrxr [expr $scrxr-$timeslider(swidth)]\n\
\n\
set nxpoints 8\n\
set nypoints 6\n\
\n\
set yincr [expr ($maxy_-$miny_)/$nypoints.0]\n\
set xincr [expr ($maxx_-$minx_)/$nxpoints.0]\n\
\n\
for {set i 1} {$i<$nypoints} {incr i} {\n\
set yval [expr $miny_+$i*$yincr]\n\
set yval [expr int($yval)]\n\
set ypos [expr $scryb-($scryb*($yval-$miny_)/($maxy_-$miny_))]\n\
set yval [$modelobj_ verifyymark $yval]\n\
\n\
$c create line $scrxl $ypos [expr $scrxl+10] $ypos -fill #6725a0\n\
$c create text [expr $scrxl+15] [expr $ypos-7] -text $yval -anchor nw \\\n\
-justify left -fill #6725a0 \\\n\
-font \"-adobe-new century schoolbook-medium-r-normal--10-100-75-75-p-60-iso8859-1\"\n\
}\n\
\n\
for {set i 1} {$i<$nxpoints} {incr i} {\n\
set xpos [expr ($scrxr/$nxpoints.0)*$i + $scrxl]\n\
set xval [format \"%+7.5f\" [expr $minx_+($i*$xincr)]]\n\
$c create line $xpos 0 $xpos 10 -fill #6725a0\n\
$c create text  $xpos 15 -text $xval -anchor n\\\n\
-justify left -fill #6725a0 \\\n\
-font \"-adobe-new century schoolbook-medium-r-normal--10-100-75-75-p-60-iso8859-1\"\n\
}\n\
}\n\
\n\
NamgraphView instproc update { time } {\n\
\n\
$self instvar now_ winname_ modelobj_\n\
\n\
if ![winfo exists $winname_ ] {\n\
$modelobj_ deleteObserver $self\n\
$self destroy\n\
return\n\
}\n\
\n\
if { [string compare $time \"*\"] != 0 } {\n\
\n\
set now_ $time\n\
$self draw_traceline $now_\n\
}\n\
\n\
}\n\
\n\
\n\
\n\
\n\
\n\
\n\
\n\
\n\
\n\
\n\
\n\
\n\
\n\
\n\
Class NamgraphModel -superclass Observable\n\
\n\
NamgraphModel instproc init { nid obs } {\n\
\n\
$self next\n\
\n\
$self instvar id_ datacount Maxy_ Maxx_ animator_id_ timeslider_swidth_\n\
set id_ $nid\n\
set datacount 0\n\
set animator_id_ $obs\n\
\n\
set Maxy_ [$obs set highest_seq($id_)]\n\
set Maxx_ [$obs set maxtime]\n\
\n\
set timeslider_swidth_ [$obs set timeslider(swidth)]\n\
\n\
}\n\
\n\
NamgraphModel instproc id {} {\n\
$self instvar id_\n\
\n\
return $id_\n\
\n\
}\n\
\n\
NamgraphModel instproc animator {} {\n\
\n\
$self instvar animator_id_\n\
return $animator_id_\n\
\n\
}\n\
\n\
NamgraphModel instproc adddata { ob mid x y ymark } {\n\
\n\
$self instvar dataname datacount id_ dataplotx dataploty\n\
$self instvar plotmark plotcolor dataplotym\n\
\n\
$self tkvar midbuilder\n\
\n\
if ![info exists midbuilder($mid)] {\n\
set midbuilder($mid) $datacount\n\
\n\
set mname [$ob set filter_id($mid)]\n\
set pmark [$ob set plotmark($id_.$mid)]\n\
set pcolor [$ob set plotcolor($id_.$mid)]\n\
set pcolor [$ob set colorname($pcolor)]\n\
\n\
set dataname($datacount) $mname \n\
set plotmark($datacount) $pmark\n\
set plotcolor($datacount) $pcolor\n\
incr datacount\n\
}\n\
\n\
set current_index $midbuilder($mid)\n\
\n\
lappend dataplotx($current_index) $x\n\
lappend dataploty($current_index) $y\n\
set dataplotym($y) $ymark\n\
\n\
}\n\
\n\
NamgraphModel instproc verifyymark { index } {\n\
\n\
$self instvar dataplotym\n\
\n\
if [info exists dataplotym($index)] {\n\
\n\
return $dataplotym($index)\n\
\n\
}\n\
\n\
return \"\"\n\
\n\
}\n\
\n\
NamgraphModel instproc startview {title} {\n\
\n\
$self instvar Maxy_ Maxx_\n\
\n\
set vob [new NamgraphView $title $self 0 $Maxx_ 0 $Maxy_ 1]\n\
$self addObserver $vob\n\
}\n\
\n\
\n\
NamgraphModel instproc update { arg } {\n\
\n\
\n\
set now [get_trace_item \"-t\" $arg]\n\
if { $now == \"\" } {\n\
set now $arg\n\
$self notifyObservers $now \n\
} else {\n\
\n\
\n\
}\n\
\n\
}\n\
\n\
\n\
set tk_strictMotif 0\n\
\n\
set uscale(m) 1e-3\n\
set uscale(u) 1e-6\n\
set uscale(k) 1e3\n\
set uscale(K) 1e3\n\
set uscale(M) 1e6\n\
\n\
set ANIMATOR_CONTROL_CLASS AnimControl\n\
\n\
Animator set id_ 0\n\
\n\
AnimControl set instance_ 	\"\"\n\
AnimControl set INIT_PORT_ 	24443	;# Arbitrary value\n\
AnimControl set PORT_FILE_ 	\"[glob ~]/.nam-port\"\n\
;# File which stores server port\n\
\n\
AnimControl set ANIMATOR_CLASS_	Animator\n\
;# Overwrite this in .nam.tcl to use derived animator class\n\
\n\
Animator set welcome \"                               Welcome to NamGraph 1.0                         \"\n\
\n\
\n\
proc nam_init { trace_file args } {\n\
set actrl [new AnimControl $trace_file $args]\n\
\n\
nam_init_hook\n\
}\n\
\n\
proc nam_init_hook {} {\n\
}\n\
\n\
\n\
set defaultRNG [new RNG]\n\
$defaultRNG seed 1\n\
$defaultRNG default\n\
trace variable defaultRNG w { abort \"cannot update defaultRNG once assigned\"; }\n\
\n\
";
#include "tclcl.h"
EmbeddedTcl et_nam(code);
